Special features
Direction of movement
When building routes for transport, you can specify the current direction of movement (or the desired direction of movement at the start) for the starting or ending point.
This helps minimize the number of maneuvers: for example, if a vehicle is moving north (or stopped on the side of the road where only moving north is possible), the route will be built to ensure the start of movement aligns with the northward direction. This feature is particularly useful in urban environments where GPS may inaccurately determine the vehicle position on a multi-lane road.
Taking direction of movement into account for building routes by public transport is not available.
An example of building a car route with different directions of movement for the start point:
To specify the movement direction vector, send a POST request to /routing/7.0.0/global with the following parameters:
-
points(mandatory parameter) - array of coordinates of route points. Specify at least two points: starting and ending.Add to the starting or ending point of the route the
azimuthparameter with a value between 0 and 360 degrees, where 0 represents north. -
transport- transportation type. -
output- result format:summary- simplified output, only time and route length in the responsedetailed- full output with route geometry
-
locale- language of text descriptions of route elements: English.
Request example:
curl --request POST \
--url 'https://routing.api.2gis.com/routing/7.0.0/global?key=API_KEY' \
--header 'Content-Type: application/json' \
--data '{
"points": [
{
"type": "stop",
"lon": 37.582591,
"lat": 55.775364,
"azimuth": 100
},
{
"type": "stop",
"lon": 37.656625,
"lat": 55.765036
}
],
"transport": "driving",
"output": "detailed",
"locale": "en"
}'
Response example:
response.json
{
"message": null,
"query": {
"locale": "en",
"output": "detailed",
"points": [
{
"azimuth": 100,
"lat": 55.775364,
"lon": 37.582591,
"type": "stop"
},
{
"lat": 55.765036,
"lon": 37.656625,
"type": "stop"
}
],
"transport": "driving"
},
"result": [
{
"algorithm": "with traffic jams",
"begin_pedestrian_path": {
"geometry": {
"selection": "LINESTRING(37.582590 55.775363, 37.583086 55.775486)"
}
},
"end_pedestrian_path": {
"geometry": {
"selection": "LINESTRING(37.656553 55.765080, 37.656625 55.765036)"
}
},
"filter_road_types": [
"highway"
],
"id": "16575802903323463471",
"maneuvers": [
{
"comment": "start",
"icon": "start",
"id": "14964400966526940870",
"outcoming_path": {
"distance": 30,
"duration": 11,
"geometry": [
{
"color": "slow",
"length": 30,
"selection": "LINESTRING(37.583086 55.775486, 37.583150 55.775405, 37.583231 55.775307, 37.583253 55.775281, 37.583307 55.775231)",
"style": "normal"
}
],
"names": [
"площадь Тверская Застава"
]
},
"outcoming_path_comment": "30 m straight",
"type": "begin"
},
{
"comment": "Left turn",
"icon": "crossroad_left",
"id": "10021740578813756429",
"outcoming_path": {
"distance": 164,
"duration": 144,
"geometry": [
{
"color": "slow-jams",
"length": 76,
"selection": "LINESTRING(37.583307 55.775231, 37.583561 55.775318, 37.583628 55.775341, 37.583734 55.775385, 37.583827 55.775434, 37.584035 55.775570, 37.584217 55.775689)",
"style": "normal"
},
{
"color": "slow",
"length": 88,
"selection": "LINESTRING(37.584217 55.775689, 37.584347 55.775775, 37.584624 55.775956, 37.584979 55.776188, 37.585058 55.776240, 37.585154 55.776303)",
"style": "normal"
}
],
"names": []
},
"outcoming_path_comment": "150 m straight",
"turn_angle": -92,
"turn_direction": "left",
"type": "crossroad"
},
{
"comment": "Right turn onto 1-я Тверская-Ямская",
"icon": "crossroad_right",
"id": "10767930650146938179",
"outcoming_path": {
"distance": 1256,
"duration": 174,
"geometry": [
{
"color": "fast",
"length": 28,
"selection": "LINESTRING(37.585154 55.776303, 37.585445 55.776157, 37.585492 55.776131)",
"style": "normal"
},
{
"color": "normal",
"length": 250,
"selection": "LINESTRING(37.585492 55.776131, 37.585658 55.776039, 37.586214 55.775714, 37.588010 55.774663, 37.588280 55.774505)",
"style": "normal"
},
{
"color": "fast",
"length": 821,
"selection": "LINESTRING(37.588280 55.774505, 37.590369 55.773281, 37.590635 55.773126, 37.592026 55.772311, 37.592333 55.772132, 37.594081 55.771108, 37.594993 55.770574, 37.595598 55.770219, 37.595740 55.770136, 37.595903 55.770019, 37.596125 55.769859, 37.596682 55.769461, 37.596711 55.769445, 37.597332 55.769104)",
"style": "normal"
},
{
"color": "normal",
"length": 157,
"selection": "LINESTRING(37.597332 55.769104, 37.598026 55.768722, 37.599143 55.768109)",
"style": "normal"
}
],
"names": [
"1-я Тверская-Ямская"
]
},
"outcoming_path_comment": "1.3 km straight",
"turn_angle": 91,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Right turn onto Благовещенский переулок",
"icon": "crossroad_right",
"id": "8774719949603556994",
"outcoming_path": {
"distance": 282,
"duration": 101,
"geometry": [
{
"color": "fast",
"length": 282,
"selection": "LINESTRING(37.599143 55.768109, 37.598984 55.768020, 37.598729 55.767877, 37.598486 55.767739, 37.598367 55.767674, 37.598289 55.767630, 37.598123 55.767537, 37.598037 55.767479, 37.597972 55.767421, 37.597911 55.767336, 37.597851 55.767189, 37.597840 55.767160, 37.597813 55.767093, 37.597784 55.767047, 37.597727 55.767009, 37.597296 55.766836, 37.596096 55.766356, 37.595993 55.766315)",
"style": "normal"
}
],
"names": [
"Благовещенский переулок"
]
},
"outcoming_path_comment": "300 m straight",
"turn_angle": 91,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Right turn onto Ермолаевский переулок",
"icon": "crossroad_right",
"id": "5797914844242090132",
"outcoming_path": {
"distance": 165,
"duration": 117,
"geometry": [
{
"color": "slow",
"length": 165,
"selection": "LINESTRING(37.595993 55.766315, 37.595925 55.766348, 37.595858 55.766362, 37.595846 55.766364, 37.595702 55.766372, 37.595123 55.766406, 37.595074 55.766409, 37.594998 55.766409, 37.594939 55.766408, 37.594813 55.766399, 37.594681 55.766371, 37.594660 55.766363, 37.593957 55.766079, 37.593699 55.765975, 37.593599 55.765935)",
"style": "normal"
}
],
"names": [
"Ермолаевский переулок"
]
},
"outcoming_path_comment": "150 m straight",
"turn_angle": 67,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Right turn onto аллея Архитектора Шехтеля",
"icon": "crossroad_right",
"id": "7401106524196196806",
"outcoming_path": {
"distance": 130,
"duration": 185,
"geometry": [
{
"color": "slow-jams",
"length": 114,
"selection": "LINESTRING(37.593599 55.765935, 37.593518 55.765985, 37.592996 55.766304, 37.592626 55.766531, 37.592353 55.766698)",
"style": "normal"
},
{
"color": "normal",
"length": 16,
"selection": "LINESTRING(37.592353 55.766698, 37.592175 55.766807)",
"style": "normal"
}
],
"names": [
"аллея Архитектора Шехтеля"
]
},
"outcoming_path_comment": "150 m straight",
"turn_angle": 83,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Right turn onto Большая Садовая",
"icon": "crossroad_right",
"id": "53672303245462145",
"outcoming_path": {
"distance": 4544,
"duration": 600,
"geometry": [
{
"color": "fast",
"length": 319,
"selection": "LINESTRING(37.592175 55.766807, 37.592529 55.767054, 37.592988 55.767375, 37.593622 55.767817, 37.594008 55.768087, 37.594339 55.768318, 37.594632 55.768511, 37.594932 55.768694, 37.595214 55.768858, 37.595486 55.769004)",
"style": "normal"
},
{
"color": "fast",
"length": 196,
"selection": "LINESTRING(37.595486 55.769004, 37.596007 55.769269, 37.596454 55.769495, 37.596797 55.769669, 37.597193 55.769869, 37.597838 55.770195)",
"style": "tunnel"
},
{
"color": "normal",
"length": 484,
"selection": "LINESTRING(37.597838 55.770195, 37.598115 55.770332, 37.598389 55.770458, 37.598674 55.770579, 37.599125 55.770758, 37.599606 55.770937, 37.599820 55.771001, 37.600450 55.771189, 37.600775 55.771293, 37.601329 55.771460, 37.602336 55.771763, 37.602421 55.771789, 37.602861 55.771922, 37.603929 55.772247, 37.604227 55.772338, 37.604516 55.772426)",
"style": "normal"
},
{
"color": "slow",
"length": 46,
"selection": "LINESTRING(37.604516 55.772426, 37.605210 55.772564)",
"style": "normal"
},
{
"color": "normal",
"length": 119,
"selection": "LINESTRING(37.605210 55.772564, 37.605213 55.772565, 37.605268 55.772575, 37.605728 55.772651, 37.605822 55.772664, 37.607062 55.772839)",
"style": "normal"
},
{
"color": "slow",
"length": 122,
"selection": "LINESTRING(37.607062 55.772839, 37.607333 55.772877, 37.607382 55.772884, 37.608251 55.772986, 37.608986 55.773080)",
"style": "normal"
},
{
"color": "normal",
"length": 109,
"selection": "LINESTRING(37.608986 55.773080, 37.609121 55.773096, 37.609234 55.773109, 37.610156 55.773194, 37.610728 55.773247)",
"style": "normal"
},
{
"color": "slow",
"length": 172,
"selection": "LINESTRING(37.610728 55.773247, 37.611026 55.773277, 37.611498 55.773310, 37.612248 55.773363, 37.612442 55.773370, 37.613457 55.773408)",
"style": "normal"
},
{
"color": "normal",
"length": 244,
"selection": "LINESTRING(37.613457 55.773408, 37.615054 55.773470, 37.617345 55.773557)",
"style": "normal"
},
{
"color": "slow",
"length": 370,
"selection": "LINESTRING(37.617345 55.773557, 37.619000 55.773621, 37.619209 55.773628, 37.621035 55.773684, 37.621922 55.773690, 37.623161 55.773671, 37.623250 55.773668)",
"style": "bridge"
},
{
"color": "slow",
"length": 462,
"selection": "LINESTRING(37.623250 55.773668, 37.624510 55.773622, 37.625672 55.773548, 37.625906 55.773531, 37.626549 55.773483, 37.627213 55.773398, 37.627407 55.773378, 37.627898 55.773317, 37.628220 55.773274, 37.629057 55.773153, 37.630300 55.772978, 37.630537 55.772946)",
"style": "normal"
},
{
"color": "normal",
"length": 82,
"selection": "LINESTRING(37.630537 55.772946, 37.631810 55.772768)",
"style": "normal"
},
{
"color": "slow",
"length": 45,
"selection": "LINESTRING(37.631810 55.772768, 37.631859 55.772761, 37.632302 55.772699, 37.632528 55.772668)",
"style": "normal"
},
{
"color": "normal",
"length": 80,
"selection": "LINESTRING(37.632528 55.772668, 37.633038 55.772597, 37.633286 55.772569, 37.633809 55.772511)",
"style": "normal"
},
{
"color": "fast",
"length": 231,
"selection": "LINESTRING(37.633809 55.772511, 37.635934 55.772276, 37.636482 55.772197, 37.636863 55.772130, 37.637246 55.772053, 37.637383 55.772024)",
"style": "normal"
},
{
"color": "normal",
"length": 688,
"selection": "LINESTRING(37.637383 55.772024, 37.637746 55.771946, 37.638398 55.771787, 37.638671 55.771709, 37.639223 55.771539, 37.639458 55.771467, 37.640138 55.771258, 37.641596 55.770815, 37.642386 55.770573, 37.642720 55.770474, 37.642942 55.770406, 37.643525 55.770234, 37.643708 55.770178, 37.643975 55.770092, 37.644348 55.769976, 37.644647 55.769882, 37.645657 55.769580, 37.645818 55.769531, 37.646121 55.769442, 37.646389 55.769364, 37.647223 55.769158)",
"style": "normal"
},
{
"color": "fast",
"length": 682,
"selection": "LINESTRING(37.647223 55.769158, 37.647789 55.769017, 37.648564 55.768776, 37.649337 55.768557, 37.649691 55.768459, 37.649817 55.768424, 37.649886 55.768391, 37.650113 55.768283, 37.650280 55.768171, 37.651022 55.767635, 37.651497 55.767307, 37.651966 55.766988, 37.652654 55.766522, 37.653423 55.765990, 37.653591 55.765874, 37.653911 55.765652, 37.654967 55.764923)",
"style": "normal"
},
{
"color": "normal",
"length": 93,
"selection": "LINESTRING(37.654967 55.764923, 37.655597 55.764466, 37.655881 55.764258)",
"style": "normal"
}
],
"names": [
"Большая Садовая"
]
},
"outcoming_path_comment": "4.5 km straight",
"turn_angle": 82,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "U-turn on Садовая-Черногрязская",
"icon": "turn_over_right_hand",
"id": "14314414070521980904",
"outcoming_path": {
"distance": 71,
"duration": 13,
"geometry": [
{
"color": "fast",
"length": 22,
"selection": "LINESTRING(37.655881 55.764258, 37.655917 55.764246, 37.655955 55.764239, 37.655993 55.764237, 37.656027 55.764240, 37.656049 55.764245, 37.656067 55.764253, 37.656086 55.764271, 37.656095 55.764288, 37.656094 55.764310, 37.656076 55.764339)",
"style": "normal"
},
{
"color": "normal",
"length": 49,
"selection": "LINESTRING(37.656076 55.764339, 37.655591 55.764691)",
"style": "normal"
}
],
"names": [
"Садовая-Черногрязская"
]
},
"outcoming_path_comment": "70 m straight",
"turn_angle": -180,
"turn_direction": "uturn_left",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "18049686830456112950",
"outcoming_path": {
"distance": 36,
"duration": 10,
"geometry": [
{
"color": "ignore",
"length": 21,
"selection": "LINESTRING(37.655591 55.764691, 37.655782 55.764778, 37.655867 55.764818)",
"style": "living_zone"
},
{
"color": "ignore",
"length": 12,
"selection": "LINESTRING(37.655867 55.764818, 37.656014 55.764887)",
"style": "archway"
},
{
"color": "ignore",
"length": 3,
"selection": "LINESTRING(37.656014 55.764887, 37.656064 55.764909)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "40 m straight",
"turn_angle": 89,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "2565047204971618498",
"outcoming_path": {
"distance": 93,
"duration": 26,
"geometry": [
{
"color": "ignore",
"length": 93,
"selection": "LINESTRING(37.656064 55.764909, 37.656554 55.764570, 37.656591 55.764558, 37.656635 55.764560, 37.656674 55.764578, 37.656728 55.764601, 37.656741 55.764609, 37.656749 55.764617, 37.656755 55.764630, 37.656755 55.764641, 37.656749 55.764655, 37.656538 55.764857)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "90 m straight",
"turn_angle": 90,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Left turn",
"icon": "crossroad_left",
"id": "6889837678521268852",
"outcoming_path": {
"distance": 21,
"duration": 6,
"geometry": [
{
"color": "ignore",
"length": 21,
"selection": "LINESTRING(37.656538 55.764857, 37.656510 55.764857, 37.656485 55.764865, 37.656303 55.764992)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "20 m straight",
"turn_angle": -46,
"turn_direction": "left",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "11293981419993868874",
"outcoming_path": {
"distance": 18,
"duration": 5,
"geometry": [
{
"color": "ignore",
"length": 18,
"selection": "LINESTRING(37.656303 55.764992, 37.656543 55.765075, 37.656553 55.765080)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "20 m straight",
"turn_angle": 91,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "finish",
"icon": "finish",
"id": "16377021944685554640",
"outcoming_path_comment": "You have arrived!",
"type": "end"
}
],
"reliability": 0.0,
"route_id": "moscow-cr-back.m1/carrouting/1772722787.209039",
"total_distance": 6810,
"total_duration": 1392,
"type": "carrouting",
"ui_total_distance": {
"unit": "km",
"value": "6.8"
},
"ui_total_duration": "23 min",
"waypoints": [
{
"original_point": {
"lat": 55.77548691400483,
"lon": 37.58308675494588
},
"projected_point": {
"lat": 55.77548691400483,
"lon": 37.58308675494588
},
"transit": false
},
{
"original_point": {
"lat": 55.76508099601444,
"lon": 37.65655367382703
},
"projected_point": {
"lat": 55.76508099601444,
"lon": 37.65655367382703
},
"transit": false
}
]
},
{
"algorithm": "with traffic jams",
"begin_pedestrian_path": {
"geometry": {
"selection": "LINESTRING(37.582590 55.775363, 37.583086 55.775486)"
}
},
"end_pedestrian_path": {
"geometry": {
"selection": "LINESTRING(37.656553 55.765080, 37.656625 55.765036)"
}
},
"filter_road_types": [
"highway"
],
"id": "8903101905601495145",
"maneuvers": [
{
"comment": "start",
"icon": "start",
"id": "1095330764536642480",
"outcoming_path": {
"distance": 30,
"duration": 11,
"geometry": [
{
"color": "slow",
"length": 30,
"selection": "LINESTRING(37.583086 55.775486, 37.583150 55.775405, 37.583231 55.775307, 37.583253 55.775281, 37.583307 55.775231)",
"style": "normal"
}
],
"names": [
"площадь Тверская Застава"
]
},
"outcoming_path_comment": "30 m straight",
"type": "begin"
},
{
"comment": "Left turn",
"icon": "crossroad_left",
"id": "14045255528057190520",
"outcoming_path": {
"distance": 164,
"duration": 145,
"geometry": [
{
"color": "slow-jams",
"length": 76,
"selection": "LINESTRING(37.583307 55.775231, 37.583561 55.775318, 37.583628 55.775341, 37.583734 55.775385, 37.583827 55.775434, 37.584035 55.775570, 37.584217 55.775689)",
"style": "normal"
},
{
"color": "slow",
"length": 88,
"selection": "LINESTRING(37.584217 55.775689, 37.584347 55.775775, 37.584624 55.775956, 37.584979 55.776188, 37.585058 55.776240, 37.585154 55.776303)",
"style": "normal"
}
],
"names": []
},
"outcoming_path_comment": "150 m straight",
"turn_angle": -92,
"turn_direction": "left",
"type": "crossroad"
},
{
"comment": "Right turn onto 1-я Тверская-Ямская",
"icon": "crossroad_right",
"id": "11872306517818021645",
"outcoming_path": {
"distance": 2525,
"duration": 552,
"geometry": [
{
"color": "fast",
"length": 28,
"selection": "LINESTRING(37.585154 55.776303, 37.585445 55.776157, 37.585492 55.776131)",
"style": "normal"
},
{
"color": "normal",
"length": 250,
"selection": "LINESTRING(37.585492 55.776131, 37.585658 55.776039, 37.586214 55.775714, 37.588010 55.774663, 37.588280 55.774505)",
"style": "normal"
},
{
"color": "fast",
"length": 881,
"selection": "LINESTRING(37.588280 55.774505, 37.590369 55.773281, 37.590635 55.773126, 37.592026 55.772311, 37.592333 55.772132, 37.594081 55.771108, 37.594993 55.770574, 37.595598 55.770219, 37.595740 55.770136, 37.595903 55.770019, 37.596125 55.769859, 37.596682 55.769461, 37.596711 55.769445, 37.597332 55.769104, 37.598026 55.768722)",
"style": "normal"
},
{
"color": "normal",
"length": 249,
"selection": "LINESTRING(37.598026 55.768722, 37.599143 55.768109, 37.599686 55.767811, 37.600043 55.767616, 37.600420 55.767408, 37.600897 55.767147)",
"style": "normal"
},
{
"color": "slow",
"length": 208,
"selection": "LINESTRING(37.600897 55.767147, 37.601521 55.766805, 37.601900 55.766596, 37.602422 55.766310, 37.603289 55.765833)",
"style": "normal"
},
{
"color": "normal",
"length": 84,
"selection": "LINESTRING(37.603289 55.765833, 37.603830 55.765536, 37.604201 55.765332, 37.604264 55.765298)",
"style": "normal"
},
{
"color": "slow",
"length": 115,
"selection": "LINESTRING(37.604264 55.765298, 37.605221 55.764772, 37.605331 55.764712, 37.605589 55.764564)",
"style": "normal"
},
{
"color": "slow-jams",
"length": 27,
"selection": "LINESTRING(37.605589 55.764564, 37.605755 55.764468, 37.605892 55.764379)",
"style": "normal"
},
{
"color": "slow",
"length": 46,
"selection": "LINESTRING(37.605892 55.764379, 37.605943 55.764346, 37.606052 55.764261, 37.606330 55.764042)",
"style": "normal"
},
{
"color": "normal",
"length": 209,
"selection": "LINESTRING(37.606330 55.764042, 37.607409 55.763195, 37.608277 55.762513)",
"style": "normal"
},
{
"color": "fast",
"length": 41,
"selection": "LINESTRING(37.608277 55.762513, 37.608419 55.762402, 37.608663 55.762210)",
"style": "normal"
},
{
"color": "normal",
"length": 234,
"selection": "LINESTRING(37.608663 55.762210, 37.608964 55.761973, 37.609189 55.761797, 37.609668 55.761364, 37.610581 55.760402)",
"style": "normal"
},
{
"color": "slow",
"length": 153,
"selection": "LINESTRING(37.610581 55.760402, 37.611732 55.759187)",
"style": "normal"
}
],
"names": [
"1-я Тверская-Ямская"
]
},
"outcoming_path_comment": "2.5 km straight",
"turn_angle": 91,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "U-turn on Тверская",
"icon": "turn_over_right_hand",
"id": "5598394030441334094",
"outcoming_path": {
"distance": 1499,
"duration": 379,
"geometry": [
{
"color": "normal",
"length": 13,
"selection": "LINESTRING(37.611732 55.759187, 37.611902 55.759266)",
"style": "normal"
},
{
"color": "fast",
"length": 327,
"selection": "LINESTRING(37.611902 55.759266, 37.611859 55.759310, 37.610921 55.760302, 37.610052 55.761218, 37.609858 55.761422, 37.609373 55.761859)",
"style": "normal"
},
{
"color": "normal",
"length": 512,
"selection": "LINESTRING(37.609373 55.761859, 37.609260 55.761948, 37.609138 55.762044, 37.608839 55.762279, 37.608430 55.762600, 37.606823 55.763860, 37.606117 55.764416, 37.605917 55.764547, 37.605693 55.764675, 37.605494 55.764790, 37.605415 55.764833, 37.604406 55.765387, 37.604263 55.765465)",
"style": "normal"
},
{
"color": "slow",
"length": 647,
"selection": "LINESTRING(37.604263 55.765465, 37.604023 55.765598, 37.603497 55.765886, 37.603395 55.765942, 37.603281 55.766005, 37.602574 55.766393, 37.601737 55.766853, 37.601394 55.767041, 37.600794 55.767371, 37.600421 55.767575, 37.600224 55.767683, 37.599668 55.767989, 37.599563 55.768046, 37.599407 55.768132, 37.598228 55.768780, 37.597641 55.769101, 37.597139 55.769377, 37.596843 55.769539, 37.596803 55.769568)",
"style": "normal"
}
],
"names": [
"Тверская"
]
},
"outcoming_path_comment": "1.5 km straight",
"turn_angle": -180,
"turn_direction": "uturn_left",
"type": "crossroad"
},
{
"comment": "Right turn onto Садовая-Триумфальная",
"icon": "crossroad_right",
"id": "12247843049904506836",
"outcoming_path": {
"distance": 4121,
"duration": 589,
"geometry": [
{
"color": "slow",
"length": 99,
"selection": "LINESTRING(37.596803 55.769568, 37.596913 55.769622, 37.597528 55.769925, 37.597712 55.769998, 37.597758 55.770016, 37.597879 55.770065, 37.597893 55.770070, 37.597910 55.770077, 37.597934 55.770090, 37.598008 55.770158)",
"style": "normal"
},
{
"color": "normal",
"length": 212,
"selection": "LINESTRING(37.598008 55.770158, 37.598076 55.770192, 37.598210 55.770249, 37.599275 55.770728, 37.599882 55.770936, 37.600050 55.770989, 37.600407 55.771103, 37.600831 55.771230)",
"style": "normal"
},
{
"color": "fast",
"length": 40,
"selection": "LINESTRING(37.600831 55.771230, 37.600914 55.771254, 37.600957 55.771272, 37.601329 55.771460)",
"style": "normal"
},
{
"color": "normal",
"length": 225,
"selection": "LINESTRING(37.601329 55.771460, 37.602336 55.771763, 37.602421 55.771789, 37.602861 55.771922, 37.603929 55.772247, 37.604227 55.772338, 37.604516 55.772426)",
"style": "normal"
},
{
"color": "slow",
"length": 46,
"selection": "LINESTRING(37.604516 55.772426, 37.605210 55.772564)",
"style": "normal"
},
{
"color": "normal",
"length": 119,
"selection": "LINESTRING(37.605210 55.772564, 37.605213 55.772565, 37.605268 55.772575, 37.605728 55.772651, 37.605822 55.772664, 37.607062 55.772839)",
"style": "normal"
},
{
"color": "slow",
"length": 122,
"selection": "LINESTRING(37.607062 55.772839, 37.607333 55.772877, 37.607382 55.772884, 37.608251 55.772986, 37.608986 55.773080)",
"style": "normal"
},
{
"color": "normal",
"length": 109,
"selection": "LINESTRING(37.608986 55.773080, 37.609121 55.773096, 37.609234 55.773109, 37.610156 55.773194, 37.610728 55.773247)",
"style": "normal"
},
{
"color": "slow",
"length": 172,
"selection": "LINESTRING(37.610728 55.773247, 37.611026 55.773277, 37.611498 55.773310, 37.612248 55.773363, 37.612442 55.773370, 37.613457 55.773408)",
"style": "normal"
},
{
"color": "normal",
"length": 244,
"selection": "LINESTRING(37.613457 55.773408, 37.615054 55.773470, 37.617345 55.773557)",
"style": "normal"
},
{
"color": "slow",
"length": 370,
"selection": "LINESTRING(37.617345 55.773557, 37.619000 55.773621, 37.619209 55.773628, 37.621035 55.773684, 37.621922 55.773690, 37.623161 55.773671, 37.623250 55.773668)",
"style": "bridge"
},
{
"color": "slow",
"length": 462,
"selection": "LINESTRING(37.623250 55.773668, 37.624510 55.773622, 37.625672 55.773548, 37.625906 55.773531, 37.626549 55.773483, 37.627213 55.773398, 37.627407 55.773378, 37.627898 55.773317, 37.628220 55.773274, 37.629057 55.773153, 37.630300 55.772978, 37.630537 55.772946)",
"style": "normal"
},
{
"color": "normal",
"length": 82,
"selection": "LINESTRING(37.630537 55.772946, 37.631810 55.772768)",
"style": "normal"
},
{
"color": "slow",
"length": 45,
"selection": "LINESTRING(37.631810 55.772768, 37.631859 55.772761, 37.632302 55.772699, 37.632528 55.772668)",
"style": "normal"
},
{
"color": "normal",
"length": 80,
"selection": "LINESTRING(37.632528 55.772668, 37.633038 55.772597, 37.633286 55.772569, 37.633809 55.772511)",
"style": "normal"
},
{
"color": "fast",
"length": 231,
"selection": "LINESTRING(37.633809 55.772511, 37.635934 55.772276, 37.636482 55.772197, 37.636863 55.772130, 37.637246 55.772053, 37.637383 55.772024)",
"style": "normal"
},
{
"color": "normal",
"length": 688,
"selection": "LINESTRING(37.637383 55.772024, 37.637746 55.771946, 37.638398 55.771787, 37.638671 55.771709, 37.639223 55.771539, 37.639458 55.771467, 37.640138 55.771258, 37.641596 55.770815, 37.642386 55.770573, 37.642720 55.770474, 37.642942 55.770406, 37.643525 55.770234, 37.643708 55.770178, 37.643975 55.770092, 37.644348 55.769976, 37.644647 55.769882, 37.645657 55.769580, 37.645818 55.769531, 37.646121 55.769442, 37.646389 55.769364, 37.647223 55.769158)",
"style": "normal"
},
{
"color": "fast",
"length": 682,
"selection": "LINESTRING(37.647223 55.769158, 37.647789 55.769017, 37.648564 55.768776, 37.649337 55.768557, 37.649691 55.768459, 37.649817 55.768424, 37.649886 55.768391, 37.650113 55.768283, 37.650280 55.768171, 37.651022 55.767635, 37.651497 55.767307, 37.651966 55.766988, 37.652654 55.766522, 37.653423 55.765990, 37.653591 55.765874, 37.653911 55.765652, 37.654967 55.764923)",
"style": "normal"
},
{
"color": "normal",
"length": 93,
"selection": "LINESTRING(37.654967 55.764923, 37.655597 55.764466, 37.655881 55.764258)",
"style": "normal"
}
],
"names": [
"Садовая-Триумфальная"
]
},
"outcoming_path_comment": "4.1 km straight",
"turn_angle": 94,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "U-turn on Садовая-Черногрязская",
"icon": "turn_over_right_hand",
"id": "14230208136495660048",
"outcoming_path": {
"distance": 71,
"duration": 13,
"geometry": [
{
"color": "fast",
"length": 22,
"selection": "LINESTRING(37.655881 55.764258, 37.655917 55.764246, 37.655955 55.764239, 37.655993 55.764237, 37.656027 55.764240, 37.656049 55.764245, 37.656067 55.764253, 37.656086 55.764271, 37.656095 55.764288, 37.656094 55.764310, 37.656076 55.764339)",
"style": "normal"
},
{
"color": "normal",
"length": 49,
"selection": "LINESTRING(37.656076 55.764339, 37.655591 55.764691)",
"style": "normal"
}
],
"names": [
"Садовая-Черногрязская"
]
},
"outcoming_path_comment": "70 m straight",
"turn_angle": -180,
"turn_direction": "uturn_left",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "15431682724493556139",
"outcoming_path": {
"distance": 36,
"duration": 10,
"geometry": [
{
"color": "ignore",
"length": 21,
"selection": "LINESTRING(37.655591 55.764691, 37.655782 55.764778, 37.655867 55.764818)",
"style": "living_zone"
},
{
"color": "ignore",
"length": 12,
"selection": "LINESTRING(37.655867 55.764818, 37.656014 55.764887)",
"style": "archway"
},
{
"color": "ignore",
"length": 3,
"selection": "LINESTRING(37.656014 55.764887, 37.656064 55.764909)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "40 m straight",
"turn_angle": 89,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "13256111159853125035",
"outcoming_path": {
"distance": 93,
"duration": 26,
"geometry": [
{
"color": "ignore",
"length": 93,
"selection": "LINESTRING(37.656064 55.764909, 37.656554 55.764570, 37.656591 55.764558, 37.656635 55.764560, 37.656674 55.764578, 37.656728 55.764601, 37.656741 55.764609, 37.656749 55.764617, 37.656755 55.764630, 37.656755 55.764641, 37.656749 55.764655, 37.656538 55.764857)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "90 m straight",
"turn_angle": 90,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Left turn",
"icon": "crossroad_left",
"id": "16727113507613878387",
"outcoming_path": {
"distance": 21,
"duration": 6,
"geometry": [
{
"color": "ignore",
"length": 21,
"selection": "LINESTRING(37.656538 55.764857, 37.656510 55.764857, 37.656485 55.764865, 37.656303 55.764992)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "20 m straight",
"turn_angle": -46,
"turn_direction": "left",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "13598495931274832112",
"outcoming_path": {
"distance": 18,
"duration": 5,
"geometry": [
{
"color": "ignore",
"length": 18,
"selection": "LINESTRING(37.656303 55.764992, 37.656543 55.765075, 37.656553 55.765080)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "20 m straight",
"turn_angle": 91,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "finish",
"icon": "finish",
"id": "16377021944685554640",
"outcoming_path_comment": "You have arrived!",
"type": "end"
}
],
"reliability": 0.0,
"route_id": "moscow-cr-back.m1/carrouting/1772722787.209752",
"total_distance": 8578,
"total_duration": 1737,
"type": "carrouting",
"ui_total_distance": {
"unit": "km",
"value": "8.6"
},
"ui_total_duration": "28 min",
"waypoints": [
{
"original_point": {
"lat": 55.77548691400483,
"lon": 37.58308675494588
},
"projected_point": {
"lat": 55.77548691400483,
"lon": 37.58308675494588
},
"transit": false
},
{
"original_point": {
"lat": 55.76508099601444,
"lon": 37.65655367382703
},
"projected_point": {
"lat": 55.76508099601444,
"lon": 37.65655367382703
},
"transit": false
}
]
}
],
"status": "OK",
"type": "result"
}
When building routes for a moving vehicle, another issue may arise: the route is optimal only at the time of calculation, but by the time the vehicle starts moving, the route is no longer relevant (the optimal entry point to the route is already behind). For example, in taxi systems where orders are distributed among drivers: the system calculates that the taxi driver should turn right in 100 meters to take an order, but while the order is being processed, the driver misses the turn, and the new route becomes longer and irrelevant.
To address this issue, you can specify a distance from the starting point during which the vehicle will not change its primary direction of movement. The primary direction of movement refers to the most likely path for the driver (not necessarily a straight line). Add the distance_direction parameter to the starting point of the route with a value between 0 and 10,000 meters.
Request example:
curl --request POST \
--url 'https://routing.api.2gis.com/routing/7.0.0/global?key=API_KEY' \
--header 'Content-Type: application/json' \
--data '{
"points": [
{
"type": "stop",
"lon": 37.582591,
"lat": 55.775364,
"distance_direction": 500
},
{
"type": "stop",
"lon": 37.656625,
"lat": 55.765036
}
],
"transport": "driving",
"output": "detailed",
"locale": "en"
}'
The response for each route will contain a reliability field with a value between 0.0 and 1.0, indicating the likelihood that the calculated route matches the driver's actual path. A reliability of 1.0 means the calculated route will be optimal for the driver.
Indoor routing
Only pedestrian routes can be built inside buildings.
Example of building an indoor route:
To build a route inside a building (for example, to an organization in a shopping mall), send a POST request to /routing/7.0.0/global with the following parameters:
-
points(mandatory parameter) - array of coordinates of route points. Specify at least two points: starting and ending. For each point specify:object_id- identifier of the building or organization to which the point will be associated. You can get this value from the Urbi directory using Places API.floor_id- identifier of the building floor. You can get this value from the Urbi directory using Places API.
At least one of the route points must be inside a building or associated with an organization using the
object_idparameter. -
transport: walking- transportation type: on foot. -
output- result format:summary- simplified output, only time and route length in the responsedetailed- full output with route geometry
-
locale- language of text descriptions of route elements: English. -
params- additional parameters:-
pedestrian- pedestrian route parameters:use_indoor- building a route inside buildingsuse_instructions- providing navigation instructions for pedestrian routes
-
Request example:
curl --request POST \
--url 'https://routing.api.2gis.com/routing/7.0.0/global?key=API_KEY' \
--header 'Content-Type: application/json' \
--data '{
"points": [
{
"lon": 37.624836,
"lat": 55.759832,
"type": "walking",
"object_id": "70030076312136070",
"floor_id": "4504694860731166"
},
{
"lon": 37.624984,
"lat": 55.760219,
"type": "walking",
"object_id": "70000001058655912",
"floor_id": "4504694860733246"
}
],
"transport": "walking",
"output": "detailed",
"locale": "en",
"params": {
"pedestrian": {
"use_indoor": true,
"use_instructions": true
}
}
}'
Response example:
response.json
{
"message": null,
"query": {
"locale": "en",
"output": "detailed",
"params": {
"pedestrian": {
"use_indoor": true,
"use_instructions": true
}
},
"points": [
{
"floor_id": "4504694860731166",
"lat": 55.759832,
"lon": 37.624836,
"object_id": "70030076312136070",
"type": "walking"
},
{
"floor_id": "4504694860733246",
"lat": 55.760219,
"lon": 37.624984,
"object_id": "70000001058655912",
"type": "walking"
}
],
"transport": "walking"
},
"result": [
{
"algorithm": "shortest",
"begin_pedestrian_path": {
"geometry": {
"selection": "LINESTRING(37.624835 55.759832, 37.624836 55.759832)"
}
},
"end_pedestrian_path": {
"geometry": {
"selection": "LINESTRING(37.624947 55.760096, 37.624947 55.760096, 37.624984 55.760218)"
}
},
"id": "8340396212096927774",
"maneuvers": [
{
"comment": "start",
"icon": "start",
"id": "3010770699859894674",
"outcoming_path": {
"distance": 17,
"duration": 11,
"floor_from": "4504694860731166",
"floor_to": "4504694860731166",
"geometry": [
{
"length": 17,
"selection": "LINESTRING(37.624836 55.759832, 37.624797 55.759923, 37.624810 55.759984)",
"style": "indoor",
"zlevel": "zlevel-normal"
}
],
"names": []
},
"outcoming_path_comment": "20 m straight",
"type": "pedestrian_begin"
},
{
"attribute": "empty",
"comment": "Left turn",
"icon": "crossroad_left",
"id": "12576290874110980358",
"outcoming_path": {
"distance": 47,
"duration": 31,
"floor_from": "4504694860731166",
"floor_to": "4504694860731166",
"geometry": [
{
"length": 47,
"selection": "LINESTRING(37.624810 55.759984, 37.624634 55.759996, 37.624539 55.760002, 37.624280 55.760019, 37.624306 55.760148)",
"style": "indoor",
"zlevel": "zlevel-normal"
}
],
"names": []
},
"outcoming_path_comment": "50 m straight",
"turn_angle": -90,
"turn_direction": "left",
"type": "pedestrian_crossroad"
},
{
"attribute": "empty",
"comment": "Right turn",
"icon": "crossroad_right",
"id": "15192561963213118306",
"outcoming_path": {
"distance": 13,
"duration": 9,
"floor_from": "4504694860731166",
"floor_to": "4504694860731166",
"geometry": [
{
"length": 13,
"selection": "LINESTRING(37.624306 55.760148, 37.624519 55.760135)",
"style": "indoor",
"zlevel": "zlevel-normal"
}
],
"names": []
},
"outcoming_path_comment": "10 m straight",
"turn_angle": 90,
"turn_direction": "right",
"type": "pedestrian_crossroad"
},
{
"comment": "on the escalator to the 2 floor",
"floor_from": "4504694860731166",
"floor_from_name": "1",
"floor_to": "4504694860733246",
"floor_to_name": "2",
"icon": "indoor_floor_change_escalator",
"id": "16092885881736972623",
"outcoming_path": {
"distance": 12,
"duration": 8,
"floor_from": "4504694860731166",
"floor_to": "4504694860733246",
"geometry": [
{
"length": 4,
"selection": "LINESTRING(37.624519 55.760135, 37.624519 55.760135)",
"style": "escalator",
"zlevel": "zlevel-normal"
},
{
"length": 8,
"selection": "LINESTRING(37.624519 55.760135, 37.624652 55.760126)",
"style": "indoor",
"zlevel": "zlevel-normal"
}
],
"names": []
},
"outcoming_path_comment": "10 m straight",
"type": "indoor_floor_change"
},
{
"attribute": "empty",
"comment": "Right turn",
"icon": "crossroad_right",
"id": "14840865112950649726",
"outcoming_path": {
"distance": 14,
"duration": 9,
"floor_from": "4504694860733246",
"floor_to": "4504694860733246",
"geometry": [
{
"length": 14,
"selection": "LINESTRING(37.624652 55.760126, 37.624651 55.760122, 37.624660 55.760121, 37.624654 55.760090, 37.624647 55.760090, 37.624644 55.760087, 37.624627 55.760000)",
"style": "indoor",
"zlevel": "zlevel-normal"
}
],
"names": []
},
"outcoming_path_comment": "10 m straight",
"turn_angle": 90,
"turn_direction": "right",
"type": "pedestrian_crossroad"
},
{
"attribute": "empty",
"comment": "Left turn",
"icon": "crossroad_left",
"id": "11619585624579699653",
"outcoming_path": {
"distance": 18,
"duration": 12,
"floor_from": "4504694860733246",
"floor_to": "4504694860733246",
"geometry": [
{
"length": 18,
"selection": "LINESTRING(37.624627 55.760000, 37.624925 55.759981)",
"style": "indoor",
"zlevel": "zlevel-normal"
}
],
"names": []
},
"outcoming_path_comment": "20 m straight",
"turn_angle": -90,
"turn_direction": "left",
"type": "pedestrian_crossroad"
},
{
"attribute": "empty",
"comment": "Left turn",
"icon": "crossroad_left",
"id": "5765146692229381700",
"outcoming_path": {
"distance": 12,
"duration": 8,
"floor_from": "4504694860733246",
"floor_to": "4504694860733246",
"geometry": [
{
"length": 12,
"selection": "LINESTRING(37.624925 55.759981, 37.624942 55.760068, 37.624947 55.760095)",
"style": "indoor",
"zlevel": "zlevel-normal"
}
],
"names": []
},
"outcoming_path_comment": "10 m straight",
"turn_angle": -90,
"turn_direction": "left",
"type": "pedestrian_crossroad"
},
{
"comment": "finish",
"icon": "finish",
"id": "13901997665194115559",
"outcoming_path_comment": "You have arrived!",
"type": "pedestrian_end"
}
],
"reliability": 1.0,
"route_id": "moscow-pd-back.m9/pedestrianrouting/1772723232.514110",
"total_distance": 147,
"total_duration": 98,
"type": "pedestrianrouting",
"ui_total_distance": {
"unit": "m",
"value": "150"
},
"ui_total_duration": "1 min",
"waypoints": [
{
"original_point": {
"lat": 55.75983206091879,
"lon": 37.62483658659604
},
"projected_point": {
"lat": 55.75983206091879,
"lon": 37.62483658659604
},
"transit": false
},
{
"original_point": {
"lat": 55.76009600540989,
"lon": 37.62494752853362
},
"projected_point": {
"lat": 55.76009600540989,
"lon": 37.62494752853362
},
"transit": false
}
]
}
],
"status": "OK",
"type": "result"
}
Avoiding road types
Avoiding road types when building routes by public transport is not available.
To avoid roads of specific types when building a route, send a POST request to /routing/7.0.0/global with the following parameters:
-
points(mandatory parameter) - array of coordinates of route points. Specify at least two points: starting and ending. -
transport- transportation type. -
filters- exclusion of certain road types. You can specify one or more values:dirt_road- dirt roads.toll_road- toll roads.ferry- ferry crossings.highway- main streets (city arterial streets, intercity roads, and highways). Relevant for bicycle, scooter, and pedestrian routes.ban_car_road- car roads. Relevant for bicycle and scooter routes.ban_stairway- stairways without ramps. Relevant for bicycle, scooter, and pedestrian routes.
-
output- result format:summary- simplified output, only time and route length in the responsedetailed- full output with route geometry
-
locale- language of text descriptions of route elements: English.
Request example:
curl --request POST \
--url 'https://routing.api.2gis.com/routing/7.0.0/global?key=API_KEY' \
--header 'Content-Type: application/json' \
--data '{
"points": [
{
"type": "stop",
"lon": 37.582591,
"lat": 55.775364
},
{
"type": "stop",
"lon": 37.656625,
"lat": 55.765036
}
],
"transport": "driving",
"filters": [
"highway",
"ban_stairway"
],
"output": "detailed",
"locale": "en"
}'
Response example:
response.json
{
"message": null,
"query": {
"filters": [
"highway",
"ban_stairway"
],
"locale": "en",
"output": "detailed",
"points": [
{
"lat": 55.775364,
"lon": 37.582591,
"type": "stop"
},
{
"lat": 55.765036,
"lon": 37.656625,
"type": "stop"
}
],
"transport": "driving"
},
"result": [
{
"algorithm": "with traffic jams",
"begin_pedestrian_path": {
"geometry": {
"selection": "LINESTRING(37.582590 55.775363, 37.583086 55.775486)"
}
},
"end_pedestrian_path": {
"geometry": {
"selection": "LINESTRING(37.656553 55.765080, 37.656625 55.765036)"
}
},
"filter_road_types": [
"highway"
],
"id": "6014102209405171576",
"maneuvers": [
{
"comment": "start",
"icon": "start",
"id": "4835991007241873106",
"outcoming_path": {
"distance": 509,
"duration": 216,
"geometry": [
{
"color": "slow",
"length": 9,
"selection": "LINESTRING(37.583086 55.775486, 37.583150 55.775405)",
"style": "normal"
},
{
"color": "fast",
"length": 21,
"selection": "LINESTRING(37.583150 55.775405, 37.583231 55.775307, 37.583253 55.775281, 37.583307 55.775231)",
"style": "normal"
},
{
"color": "slow",
"length": 435,
"selection": "LINESTRING(37.583307 55.775231, 37.583444 55.775139, 37.583539 55.775074, 37.583571 55.775051, 37.583758 55.774941, 37.584051 55.774769, 37.584528 55.774490, 37.584715 55.774380, 37.584995 55.774215, 37.585056 55.774180, 37.585086 55.774162, 37.585701 55.773802, 37.586019 55.773616, 37.586202 55.773508, 37.586336 55.773430, 37.586461 55.773356, 37.586789 55.773163, 37.587075 55.772996, 37.587113 55.772973, 37.587238 55.772900, 37.587446 55.772778, 37.587668 55.772648, 37.587824 55.772557, 37.588158 55.772360, 37.588212 55.772329)",
"style": "normal"
},
{
"color": "fast",
"length": 44,
"selection": "LINESTRING(37.588212 55.772329, 37.588581 55.772112, 37.588708 55.772038)",
"style": "normal"
}
],
"names": [
"площадь Тверская Застава"
]
},
"outcoming_path_comment": "500 m straight",
"type": "begin"
},
{
"comment": "Left turn onto Васильевская",
"icon": "crossroad_left",
"id": "15466729535558919037",
"outcoming_path": {
"distance": 634,
"duration": 271,
"geometry": [
{
"color": "normal",
"length": 75,
"selection": "LINESTRING(37.588708 55.772038, 37.588824 55.772103, 37.588938 55.772168, 37.589561 55.772519)",
"style": "normal"
},
{
"color": "slow",
"length": 243,
"selection": "LINESTRING(37.589561 55.772519, 37.589644 55.772566, 37.589753 55.772628, 37.590258 55.772912, 37.590321 55.772949, 37.590525 55.773064, 37.590635 55.773126, 37.590786 55.773209, 37.590890 55.773267, 37.591282 55.773479, 37.591366 55.773525, 37.591436 55.773563, 37.591452 55.773572, 37.591751 55.773734, 37.592280 55.774022, 37.592386 55.774079)",
"style": "normal"
},
{
"color": "normal",
"length": 316,
"selection": "LINESTRING(37.592386 55.774079, 37.592468 55.774124, 37.593101 55.774468, 37.593299 55.774576, 37.593407 55.774635, 37.593510 55.774701, 37.593833 55.774914, 37.593906 55.774961, 37.594653 55.775451, 37.595722 55.776151, 37.595810 55.776208)",
"style": "normal"
}
],
"names": [
"Васильевская"
]
},
"outcoming_path_comment": "600 m straight",
"turn_angle": -91,
"turn_direction": "left",
"type": "crossroad"
},
{
"comment": "Right turn onto Фадеева",
"icon": "crossroad_right",
"id": "15640072892377344001",
"outcoming_path": {
"distance": 585,
"duration": 217,
"geometry": [
{
"color": "slow",
"length": 324,
"selection": "LINESTRING(37.595810 55.776208, 37.595921 55.776151, 37.596207 55.776001, 37.596427 55.775886, 37.596583 55.775805, 37.596840 55.775671, 37.597696 55.775224, 37.597839 55.775149, 37.597963 55.775085, 37.598104 55.775011, 37.598617 55.774744, 37.599057 55.774514, 37.599599 55.774231, 37.599671 55.774193)",
"style": "normal"
},
{
"color": "normal",
"length": 261,
"selection": "LINESTRING(37.599671 55.774193, 37.599731 55.774161, 37.600004 55.774020, 37.600950 55.773525, 37.601253 55.773367, 37.601480 55.773248, 37.601739 55.773113, 37.602057 55.772948, 37.602510 55.772711, 37.602608 55.772660, 37.602768 55.772576)",
"style": "normal"
}
],
"names": [
"Фадеева"
]
},
"outcoming_path_comment": "600 m straight",
"turn_angle": 92,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Sharp right turn onto Оружейный переулок",
"icon": "crossroad_sharply_right",
"id": "3856648406002991310",
"outcoming_path": {
"distance": 360,
"duration": 101,
"geometry": [
{
"color": "normal",
"length": 360,
"selection": "LINESTRING(37.602768 55.772576, 37.601284 55.772131, 37.601202 55.772107, 37.600440 55.771878, 37.599827 55.771695, 37.599553 55.771612, 37.598908 55.771419, 37.597742 55.770949)",
"style": "normal"
}
],
"names": [
"Оружейный переулок"
]
},
"outcoming_path_comment": "350 m straight",
"turn_angle": 109,
"turn_direction": "sharply_right",
"type": "crossroad"
},
{
"comment": "Keep left",
"icon": "crossroad_keep_left",
"id": "17942704015494476934",
"outcoming_path": {
"distance": 112,
"duration": 37,
"geometry": [
{
"color": "fast",
"length": 32,
"selection": "LINESTRING(37.597742 55.770949, 37.597322 55.770779)",
"style": "normal"
},
{
"color": "normal",
"length": 80,
"selection": "LINESTRING(37.597322 55.770779, 37.597245 55.770734, 37.597197 55.770689, 37.597175 55.770645, 37.597174 55.770599, 37.597186 55.770557, 37.597215 55.770514, 37.597261 55.770473, 37.597375 55.770397, 37.597450 55.770347, 37.597491 55.770320, 37.597716 55.770172)",
"style": "normal"
}
],
"names": []
},
"outcoming_path_comment": "100 m straight",
"turn_angle": -29,
"turn_direction": "keep_left",
"type": "crossroad"
},
{
"comment": "Left turn onto Садовая-Триумфальная",
"icon": "crossroad_left",
"id": "2366918160722807425",
"outcoming_path": {
"distance": 4041,
"duration": 561,
"geometry": [
{
"color": "fast",
"length": 19,
"selection": "LINESTRING(37.597716 55.770172, 37.597809 55.770140, 37.597831 55.770135, 37.597862 55.770132, 37.597883 55.770133, 37.597914 55.770137, 37.598008 55.770158)",
"style": "normal"
},
{
"color": "slow",
"length": 212,
"selection": "LINESTRING(37.598008 55.770158, 37.598076 55.770192, 37.598210 55.770249, 37.599275 55.770728, 37.599882 55.770936, 37.600050 55.770989, 37.600407 55.771103, 37.600831 55.771230)",
"style": "normal"
},
{
"color": "normal",
"length": 40,
"selection": "LINESTRING(37.600831 55.771230, 37.600914 55.771254, 37.600957 55.771272, 37.601329 55.771460)",
"style": "normal"
},
{
"color": "slow",
"length": 77,
"selection": "LINESTRING(37.601329 55.771460, 37.602336 55.771763, 37.602421 55.771789)",
"style": "normal"
},
{
"color": "normal",
"length": 443,
"selection": "LINESTRING(37.602421 55.771789, 37.602861 55.771922, 37.603929 55.772247, 37.604227 55.772338, 37.604516 55.772426, 37.605210 55.772564, 37.605213 55.772565, 37.605268 55.772575, 37.605728 55.772651, 37.605822 55.772664, 37.607062 55.772839, 37.607333 55.772877, 37.607382 55.772884, 37.608251 55.772986, 37.608986 55.773080, 37.609121 55.773096)",
"style": "normal"
},
{
"color": "fast",
"length": 273,
"selection": "LINESTRING(37.609121 55.773096, 37.609234 55.773109, 37.610156 55.773194, 37.610728 55.773247, 37.611026 55.773277, 37.611498 55.773310, 37.612248 55.773363, 37.612442 55.773370, 37.613457 55.773408)",
"style": "normal"
},
{
"color": "normal",
"length": 244,
"selection": "LINESTRING(37.613457 55.773408, 37.615054 55.773470, 37.617345 55.773557)",
"style": "normal"
},
{
"color": "normal",
"length": 370,
"selection": "LINESTRING(37.617345 55.773557, 37.619000 55.773621, 37.619209 55.773628, 37.621035 55.773684, 37.621922 55.773690, 37.623161 55.773671, 37.623250 55.773668)",
"style": "bridge"
},
{
"color": "normal",
"length": 250,
"selection": "LINESTRING(37.623250 55.773668, 37.624510 55.773622, 37.625672 55.773548, 37.625906 55.773531, 37.626549 55.773483, 37.627213 55.773398)",
"style": "normal"
},
{
"color": "slow",
"length": 294,
"selection": "LINESTRING(37.627213 55.773398, 37.627407 55.773378, 37.627898 55.773317, 37.628220 55.773274, 37.629057 55.773153, 37.630300 55.772978, 37.630537 55.772946, 37.631810 55.772768)",
"style": "normal"
},
{
"color": "normal",
"length": 3,
"selection": "LINESTRING(37.631810 55.772768, 37.631859 55.772761)",
"style": "normal"
},
{
"color": "slow",
"length": 122,
"selection": "LINESTRING(37.631859 55.772761, 37.632302 55.772699, 37.632528 55.772668, 37.633038 55.772597, 37.633286 55.772569, 37.633809 55.772511)",
"style": "normal"
},
{
"color": "fast",
"length": 581,
"selection": "LINESTRING(37.633809 55.772511, 37.635934 55.772276, 37.636482 55.772197, 37.636863 55.772130, 37.637246 55.772053, 37.637383 55.772024, 37.637746 55.771946, 37.638398 55.771787, 37.638671 55.771709, 37.639223 55.771539, 37.639458 55.771467, 37.640138 55.771258, 37.641596 55.770815, 37.642386 55.770573)",
"style": "normal"
},
{
"color": "normal",
"length": 38,
"selection": "LINESTRING(37.642386 55.770573, 37.642720 55.770474, 37.642942 55.770406)",
"style": "normal"
},
{
"color": "fast",
"length": 41,
"selection": "LINESTRING(37.642942 55.770406, 37.643525 55.770234)",
"style": "normal"
},
{
"color": "normal",
"length": 162,
"selection": "LINESTRING(37.643525 55.770234, 37.643708 55.770178, 37.643975 55.770092, 37.644348 55.769976, 37.644647 55.769882, 37.645657 55.769580, 37.645818 55.769531)",
"style": "normal"
},
{
"color": "fast",
"length": 628,
"selection": "LINESTRING(37.645818 55.769531, 37.646121 55.769442, 37.646389 55.769364, 37.647223 55.769158, 37.647789 55.769017, 37.648564 55.768776, 37.649337 55.768557, 37.649691 55.768459, 37.649817 55.768424, 37.649886 55.768391, 37.650113 55.768283, 37.650280 55.768171, 37.651022 55.767635, 37.651497 55.767307, 37.651966 55.766988, 37.652654 55.766522, 37.653423 55.765990)",
"style": "normal"
},
{
"color": "normal",
"length": 47,
"selection": "LINESTRING(37.653423 55.765990, 37.653591 55.765874, 37.653911 55.765652)",
"style": "normal"
},
{
"color": "fast",
"length": 197,
"selection": "LINESTRING(37.653911 55.765652, 37.654967 55.764923, 37.655597 55.764466, 37.655881 55.764258)",
"style": "normal"
}
],
"names": [
"Садовая-Триумфальная"
]
},
"outcoming_path_comment": "4 km straight",
"turn_angle": -91,
"turn_direction": "left",
"type": "crossroad"
},
{
"comment": "U-turn on Садовая-Черногрязская",
"icon": "turn_over_right_hand",
"id": "4493626255729929673",
"outcoming_path": {
"distance": 71,
"duration": 13,
"geometry": [
{
"color": "fast",
"length": 22,
"selection": "LINESTRING(37.655881 55.764258, 37.655917 55.764246, 37.655955 55.764239, 37.655993 55.764237, 37.656027 55.764240, 37.656049 55.764245, 37.656067 55.764253, 37.656086 55.764271, 37.656095 55.764288, 37.656094 55.764310, 37.656076 55.764339)",
"style": "normal"
},
{
"color": "slow",
"length": 49,
"selection": "LINESTRING(37.656076 55.764339, 37.655591 55.764691)",
"style": "normal"
}
],
"names": [
"Садовая-Черногрязская"
]
},
"outcoming_path_comment": "70 m straight",
"turn_angle": -180,
"turn_direction": "uturn_left",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "9157621777662694291",
"outcoming_path": {
"distance": 36,
"duration": 10,
"geometry": [
{
"color": "ignore",
"length": 21,
"selection": "LINESTRING(37.655591 55.764691, 37.655782 55.764778, 37.655867 55.764818)",
"style": "living_zone"
},
{
"color": "ignore",
"length": 12,
"selection": "LINESTRING(37.655867 55.764818, 37.656014 55.764887)",
"style": "archway"
},
{
"color": "ignore",
"length": 3,
"selection": "LINESTRING(37.656014 55.764887, 37.656064 55.764909)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "40 m straight",
"turn_angle": 89,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "6217318916145601811",
"outcoming_path": {
"distance": 93,
"duration": 25,
"geometry": [
{
"color": "ignore",
"length": 93,
"selection": "LINESTRING(37.656064 55.764909, 37.656554 55.764570, 37.656591 55.764558, 37.656635 55.764560, 37.656674 55.764578, 37.656728 55.764601, 37.656741 55.764609, 37.656749 55.764617, 37.656755 55.764630, 37.656755 55.764641, 37.656749 55.764655, 37.656538 55.764857)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "90 m straight",
"turn_angle": 90,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Left turn",
"icon": "crossroad_left",
"id": "13507075347253104752",
"outcoming_path": {
"distance": 21,
"duration": 6,
"geometry": [
{
"color": "ignore",
"length": 21,
"selection": "LINESTRING(37.656538 55.764857, 37.656510 55.764857, 37.656485 55.764865, 37.656303 55.764992)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "20 m straight",
"turn_angle": -46,
"turn_direction": "left",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "10674697447161755079",
"outcoming_path": {
"distance": 18,
"duration": 5,
"geometry": [
{
"color": "ignore",
"length": 18,
"selection": "LINESTRING(37.656303 55.764992, 37.656543 55.765075, 37.656553 55.765080)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "20 m straight",
"turn_angle": 91,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "finish",
"icon": "finish",
"id": "16377021944685554640",
"outcoming_path_comment": "You have arrived!",
"type": "end"
}
],
"reliability": 0.0,
"requested_filters": [
"highway",
"ban_stairway"
],
"result_filters": [
"ban_stairway"
],
"route_id": "moscow-cr-back.m1/carrouting/1772723742.542444",
"total_distance": 6480,
"total_duration": 1463,
"type": "carrouting",
"ui_total_distance": {
"unit": "km",
"value": "6.5"
},
"ui_total_duration": "24 min",
"waypoints": [
{
"original_point": {
"lat": 55.77548691400483,
"lon": 37.58308675494588
},
"projected_point": {
"lat": 55.77548691400483,
"lon": 37.58308675494588
},
"transit": false
},
{
"original_point": {
"lat": 55.76508099601444,
"lon": 37.65655367382703
},
"projected_point": {
"lat": 55.76508099601444,
"lon": 37.65655367382703
},
"transit": false
}
]
},
{
"algorithm": "with traffic jams",
"begin_pedestrian_path": {
"geometry": {
"selection": "LINESTRING(37.582590 55.775363, 37.583086 55.775486)"
}
},
"end_pedestrian_path": {
"geometry": {
"selection": "LINESTRING(37.656553 55.765080, 37.656625 55.765036)"
}
},
"filter_road_types": [
"highway"
],
"id": "12087620815634284703",
"maneuvers": [
{
"comment": "start",
"icon": "start",
"id": "17103873150698469622",
"outcoming_path": {
"distance": 30,
"duration": 12,
"geometry": [
{
"color": "slow",
"length": 30,
"selection": "LINESTRING(37.583086 55.775486, 37.583150 55.775405, 37.583231 55.775307, 37.583253 55.775281, 37.583307 55.775231)",
"style": "normal"
}
],
"names": [
"площадь Тверская Застава"
]
},
"outcoming_path_comment": "30 m straight",
"type": "begin"
},
{
"comment": "Left turn",
"icon": "crossroad_left",
"id": "9438251515196181272",
"outcoming_path": {
"distance": 164,
"duration": 91,
"geometry": [
{
"color": "fast",
"length": 18,
"selection": "LINESTRING(37.583307 55.775231, 37.583561 55.775318)",
"style": "normal"
},
{
"color": "slow-jams",
"length": 58,
"selection": "LINESTRING(37.583561 55.775318, 37.583628 55.775341, 37.583734 55.775385, 37.583827 55.775434, 37.584035 55.775570, 37.584217 55.775689)",
"style": "normal"
},
{
"color": "normal",
"length": 12,
"selection": "LINESTRING(37.584217 55.775689, 37.584347 55.775775)",
"style": "normal"
},
{
"color": "slow",
"length": 26,
"selection": "LINESTRING(37.584347 55.775775, 37.584624 55.775956)",
"style": "normal"
},
{
"color": "normal",
"length": 34,
"selection": "LINESTRING(37.584624 55.775956, 37.584979 55.776188)",
"style": "normal"
},
{
"color": "fast",
"length": 16,
"selection": "LINESTRING(37.584979 55.776188, 37.585058 55.776240, 37.585154 55.776303)",
"style": "normal"
}
],
"names": []
},
"outcoming_path_comment": "150 m straight",
"turn_angle": -92,
"turn_direction": "left",
"type": "crossroad"
},
{
"comment": "Right turn onto 1-я Тверская-Ямская",
"icon": "crossroad_right",
"id": "18032607513278995711",
"outcoming_path": {
"distance": 2525,
"duration": 819,
"geometry": [
{
"color": "fast",
"length": 28,
"selection": "LINESTRING(37.585154 55.776303, 37.585445 55.776157, 37.585492 55.776131)",
"style": "normal"
},
{
"color": "slow",
"length": 226,
"selection": "LINESTRING(37.585492 55.776131, 37.585658 55.776039, 37.586214 55.775714, 37.588010 55.774663)",
"style": "normal"
},
{
"color": "normal",
"length": 389,
"selection": "LINESTRING(37.588010 55.774663, 37.588280 55.774505, 37.590369 55.773281, 37.590635 55.773126, 37.592026 55.772311, 37.592333 55.772132)",
"style": "normal"
},
{
"color": "fast",
"length": 158,
"selection": "LINESTRING(37.592333 55.772132, 37.594081 55.771108)",
"style": "normal"
},
{
"color": "normal",
"length": 244,
"selection": "LINESTRING(37.594081 55.771108, 37.594993 55.770574, 37.595598 55.770219, 37.595740 55.770136, 37.595903 55.770019, 37.596125 55.769859, 37.596682 55.769461, 37.596711 55.769445)",
"style": "normal"
},
{
"color": "slow",
"length": 363,
"selection": "LINESTRING(37.596711 55.769445, 37.597332 55.769104, 37.598026 55.768722, 37.599143 55.768109, 37.599686 55.767811, 37.600043 55.767616, 37.600420 55.767408, 37.600897 55.767147)",
"style": "normal"
},
{
"color": "slow-jams",
"length": 208,
"selection": "LINESTRING(37.600897 55.767147, 37.601521 55.766805, 37.601900 55.766596, 37.602422 55.766310, 37.603289 55.765833)",
"style": "normal"
},
{
"color": "slow",
"length": 84,
"selection": "LINESTRING(37.603289 55.765833, 37.603830 55.765536, 37.604201 55.765332, 37.604264 55.765298)",
"style": "normal"
},
{
"color": "normal",
"length": 304,
"selection": "LINESTRING(37.604264 55.765298, 37.605221 55.764772, 37.605331 55.764712, 37.605589 55.764564, 37.605755 55.764468, 37.605892 55.764379, 37.605943 55.764346, 37.606052 55.764261, 37.606330 55.764042, 37.607409 55.763195)",
"style": "normal"
},
{
"color": "slow",
"length": 93,
"selection": "LINESTRING(37.607409 55.763195, 37.608277 55.762513)",
"style": "normal"
},
{
"color": "slow-jams",
"length": 275,
"selection": "LINESTRING(37.608277 55.762513, 37.608419 55.762402, 37.608663 55.762210, 37.608964 55.761973, 37.609189 55.761797, 37.609668 55.761364, 37.610581 55.760402)",
"style": "normal"
},
{
"color": "slow",
"length": 153,
"selection": "LINESTRING(37.610581 55.760402, 37.611732 55.759187)",
"style": "normal"
}
],
"names": [
"1-я Тверская-Ямская"
]
},
"outcoming_path_comment": "2.5 km straight",
"turn_angle": 91,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "U-turn on Тверская",
"icon": "turn_over_right_hand",
"id": "16035994517503818760",
"outcoming_path": {
"distance": 1499,
"duration": 398,
"geometry": [
{
"color": "slow",
"length": 13,
"selection": "LINESTRING(37.611732 55.759187, 37.611902 55.759266)",
"style": "normal"
},
{
"color": "normal",
"length": 1087,
"selection": "LINESTRING(37.611902 55.759266, 37.611859 55.759310, 37.610921 55.760302, 37.610052 55.761218, 37.609858 55.761422, 37.609373 55.761859, 37.609260 55.761948, 37.609138 55.762044, 37.608839 55.762279, 37.608430 55.762600, 37.606823 55.763860, 37.606117 55.764416, 37.605917 55.764547, 37.605693 55.764675, 37.605494 55.764790, 37.605415 55.764833, 37.604406 55.765387, 37.604263 55.765465, 37.604023 55.765598, 37.603497 55.765886, 37.603395 55.765942, 37.603281 55.766005, 37.602574 55.766393, 37.601737 55.766853, 37.601394 55.767041)",
"style": "normal"
},
{
"color": "slow",
"length": 52,
"selection": "LINESTRING(37.601394 55.767041, 37.600794 55.767371)",
"style": "normal"
},
{
"color": "slow-jams",
"length": 120,
"selection": "LINESTRING(37.600794 55.767371, 37.600421 55.767575, 37.600224 55.767683, 37.599668 55.767989, 37.599563 55.768046, 37.599407 55.768132)",
"style": "normal"
},
{
"color": "normal",
"length": 103,
"selection": "LINESTRING(37.599407 55.768132, 37.598228 55.768780)",
"style": "normal"
},
{
"color": "slow",
"length": 124,
"selection": "LINESTRING(37.598228 55.768780, 37.597641 55.769101, 37.597139 55.769377, 37.596843 55.769539, 37.596803 55.769568)",
"style": "normal"
}
],
"names": [
"Тверская"
]
},
"outcoming_path_comment": "1.5 km straight",
"turn_angle": -180,
"turn_direction": "uturn_left",
"type": "crossroad"
},
{
"comment": "Right turn onto Садовая-Триумфальная",
"icon": "crossroad_right",
"id": "15153485140960436373",
"outcoming_path": {
"distance": 4121,
"duration": 582,
"geometry": [
{
"color": "normal",
"length": 99,
"selection": "LINESTRING(37.596803 55.769568, 37.596913 55.769622, 37.597528 55.769925, 37.597712 55.769998, 37.597758 55.770016, 37.597879 55.770065, 37.597893 55.770070, 37.597910 55.770077, 37.597934 55.770090, 37.598008 55.770158)",
"style": "normal"
},
{
"color": "slow",
"length": 212,
"selection": "LINESTRING(37.598008 55.770158, 37.598076 55.770192, 37.598210 55.770249, 37.599275 55.770728, 37.599882 55.770936, 37.600050 55.770989, 37.600407 55.771103, 37.600831 55.771230)",
"style": "normal"
},
{
"color": "normal",
"length": 40,
"selection": "LINESTRING(37.600831 55.771230, 37.600914 55.771254, 37.600957 55.771272, 37.601329 55.771460)",
"style": "normal"
},
{
"color": "slow",
"length": 77,
"selection": "LINESTRING(37.601329 55.771460, 37.602336 55.771763, 37.602421 55.771789)",
"style": "normal"
},
{
"color": "normal",
"length": 443,
"selection": "LINESTRING(37.602421 55.771789, 37.602861 55.771922, 37.603929 55.772247, 37.604227 55.772338, 37.604516 55.772426, 37.605210 55.772564, 37.605213 55.772565, 37.605268 55.772575, 37.605728 55.772651, 37.605822 55.772664, 37.607062 55.772839, 37.607333 55.772877, 37.607382 55.772884, 37.608251 55.772986, 37.608986 55.773080, 37.609121 55.773096)",
"style": "normal"
},
{
"color": "fast",
"length": 273,
"selection": "LINESTRING(37.609121 55.773096, 37.609234 55.773109, 37.610156 55.773194, 37.610728 55.773247, 37.611026 55.773277, 37.611498 55.773310, 37.612248 55.773363, 37.612442 55.773370, 37.613457 55.773408)",
"style": "normal"
},
{
"color": "normal",
"length": 244,
"selection": "LINESTRING(37.613457 55.773408, 37.615054 55.773470, 37.617345 55.773557)",
"style": "normal"
},
{
"color": "normal",
"length": 370,
"selection": "LINESTRING(37.617345 55.773557, 37.619000 55.773621, 37.619209 55.773628, 37.621035 55.773684, 37.621922 55.773690, 37.623161 55.773671, 37.623250 55.773668)",
"style": "bridge"
},
{
"color": "normal",
"length": 250,
"selection": "LINESTRING(37.623250 55.773668, 37.624510 55.773622, 37.625672 55.773548, 37.625906 55.773531, 37.626549 55.773483, 37.627213 55.773398)",
"style": "normal"
},
{
"color": "slow",
"length": 294,
"selection": "LINESTRING(37.627213 55.773398, 37.627407 55.773378, 37.627898 55.773317, 37.628220 55.773274, 37.629057 55.773153, 37.630300 55.772978, 37.630537 55.772946, 37.631810 55.772768)",
"style": "normal"
},
{
"color": "normal",
"length": 3,
"selection": "LINESTRING(37.631810 55.772768, 37.631859 55.772761)",
"style": "normal"
},
{
"color": "slow",
"length": 122,
"selection": "LINESTRING(37.631859 55.772761, 37.632302 55.772699, 37.632528 55.772668, 37.633038 55.772597, 37.633286 55.772569, 37.633809 55.772511)",
"style": "normal"
},
{
"color": "fast",
"length": 581,
"selection": "LINESTRING(37.633809 55.772511, 37.635934 55.772276, 37.636482 55.772197, 37.636863 55.772130, 37.637246 55.772053, 37.637383 55.772024, 37.637746 55.771946, 37.638398 55.771787, 37.638671 55.771709, 37.639223 55.771539, 37.639458 55.771467, 37.640138 55.771258, 37.641596 55.770815, 37.642386 55.770573)",
"style": "normal"
},
{
"color": "normal",
"length": 38,
"selection": "LINESTRING(37.642386 55.770573, 37.642720 55.770474, 37.642942 55.770406)",
"style": "normal"
},
{
"color": "fast",
"length": 41,
"selection": "LINESTRING(37.642942 55.770406, 37.643525 55.770234)",
"style": "normal"
},
{
"color": "normal",
"length": 162,
"selection": "LINESTRING(37.643525 55.770234, 37.643708 55.770178, 37.643975 55.770092, 37.644348 55.769976, 37.644647 55.769882, 37.645657 55.769580, 37.645818 55.769531)",
"style": "normal"
},
{
"color": "fast",
"length": 628,
"selection": "LINESTRING(37.645818 55.769531, 37.646121 55.769442, 37.646389 55.769364, 37.647223 55.769158, 37.647789 55.769017, 37.648564 55.768776, 37.649337 55.768557, 37.649691 55.768459, 37.649817 55.768424, 37.649886 55.768391, 37.650113 55.768283, 37.650280 55.768171, 37.651022 55.767635, 37.651497 55.767307, 37.651966 55.766988, 37.652654 55.766522, 37.653423 55.765990)",
"style": "normal"
},
{
"color": "normal",
"length": 47,
"selection": "LINESTRING(37.653423 55.765990, 37.653591 55.765874, 37.653911 55.765652)",
"style": "normal"
},
{
"color": "fast",
"length": 197,
"selection": "LINESTRING(37.653911 55.765652, 37.654967 55.764923, 37.655597 55.764466, 37.655881 55.764258)",
"style": "normal"
}
],
"names": [
"Садовая-Триумфальная"
]
},
"outcoming_path_comment": "4.1 km straight",
"turn_angle": 94,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "U-turn on Садовая-Черногрязская",
"icon": "turn_over_right_hand",
"id": "13886678312228040001",
"outcoming_path": {
"distance": 71,
"duration": 14,
"geometry": [
{
"color": "fast",
"length": 22,
"selection": "LINESTRING(37.655881 55.764258, 37.655917 55.764246, 37.655955 55.764239, 37.655993 55.764237, 37.656027 55.764240, 37.656049 55.764245, 37.656067 55.764253, 37.656086 55.764271, 37.656095 55.764288, 37.656094 55.764310, 37.656076 55.764339)",
"style": "normal"
},
{
"color": "slow",
"length": 49,
"selection": "LINESTRING(37.656076 55.764339, 37.655591 55.764691)",
"style": "normal"
}
],
"names": [
"Садовая-Черногрязская"
]
},
"outcoming_path_comment": "70 m straight",
"turn_angle": -180,
"turn_direction": "uturn_left",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "12571710993016079321",
"outcoming_path": {
"distance": 36,
"duration": 10,
"geometry": [
{
"color": "ignore",
"length": 21,
"selection": "LINESTRING(37.655591 55.764691, 37.655782 55.764778, 37.655867 55.764818)",
"style": "living_zone"
},
{
"color": "ignore",
"length": 12,
"selection": "LINESTRING(37.655867 55.764818, 37.656014 55.764887)",
"style": "archway"
},
{
"color": "ignore",
"length": 3,
"selection": "LINESTRING(37.656014 55.764887, 37.656064 55.764909)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "40 m straight",
"turn_angle": 89,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "16623605703928738151",
"outcoming_path": {
"distance": 93,
"duration": 26,
"geometry": [
{
"color": "ignore",
"length": 93,
"selection": "LINESTRING(37.656064 55.764909, 37.656554 55.764570, 37.656591 55.764558, 37.656635 55.764560, 37.656674 55.764578, 37.656728 55.764601, 37.656741 55.764609, 37.656749 55.764617, 37.656755 55.764630, 37.656755 55.764641, 37.656749 55.764655, 37.656538 55.764857)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "90 m straight",
"turn_angle": 90,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Left turn",
"icon": "crossroad_left",
"id": "14738996950782572064",
"outcoming_path": {
"distance": 21,
"duration": 6,
"geometry": [
{
"color": "ignore",
"length": 21,
"selection": "LINESTRING(37.656538 55.764857, 37.656510 55.764857, 37.656485 55.764865, 37.656303 55.764992)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "20 m straight",
"turn_angle": -46,
"turn_direction": "left",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "9785013895095610403",
"outcoming_path": {
"distance": 18,
"duration": 5,
"geometry": [
{
"color": "ignore",
"length": 18,
"selection": "LINESTRING(37.656303 55.764992, 37.656543 55.765075, 37.656553 55.765080)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "20 m straight",
"turn_angle": 91,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "finish",
"icon": "finish",
"id": "16377021944685554640",
"outcoming_path_comment": "You have arrived!",
"type": "end"
}
],
"reliability": 0.0,
"requested_filters": [
"highway",
"ban_stairway"
],
"result_filters": [
"ban_stairway"
],
"route_id": "moscow-cr-back.m1/carrouting/1772723742.543223",
"total_distance": 8578,
"total_duration": 1962,
"type": "carrouting",
"ui_total_distance": {
"unit": "km",
"value": "8.6"
},
"ui_total_duration": "32 min",
"waypoints": [
{
"original_point": {
"lat": 55.77548691400483,
"lon": 37.58308675494588
},
"projected_point": {
"lat": 55.77548691400483,
"lon": 37.58308675494588
},
"transit": false
},
{
"original_point": {
"lat": 55.76508099601444,
"lon": 37.65655367382703
},
"projected_point": {
"lat": 55.76508099601444,
"lon": 37.65655367382703
},
"transit": false
}
]
}
],
"status": "OK",
"type": "result"
}
Excluding specific areas
Excluding specific areas when building routes by public transport is not available.
To exclude a specific area from the route, send a POST request to /routing/7.0.0/global with the following parameters:
-
points(mandatory parameter) - array of coordinates of route points. Specify at least two points: starting and ending. -
transport- transportation type. -
output- result format:summary- simplified output, only time and route length in the responsedetailed- full output with route geometry
-
locale- language of text descriptions of route elements: English. -
exclude- array of excluded areas. Maximum number of areas is 25. Specify for each area:-
points- array of coordinates of the excluded area points. -
type- shape of the excluded area:point- circle with a radius equal toextent(pointsrepresent the center of the circle).polyline- polyline with a width equal toextent(pointsrepresent the vertices of the line).polygon- polygon (pointsrepresent the vertices of the polygon).
-
extent- size of the excluded area in meters. -
severity- how strictly to avoid the specified area:soft- avoid if possible.hard- always avoid.
-
Request example:
curl --request POST \
--url 'https://routing.api.2gis.com/routing/7.0.0/global?key=API_KEY' \
--header 'Content-Type: application/json' \
--data '{
"points": [
{
"lon": 37.582591,
"lat": 55.775364,
"type": "stop"
},
{
"lon": 37.656625,
"lat": 55.765036,
"type": "stop"
}
],
"transport": "driving",
"output": "detailed",
"locale": "en",
"exclude": [
{
"points": [
{
"lon": 37.610243,
"lat": 55.760012
}
],
"type": "point",
"extent": 200,
"severity": "hard"
}
]
}'
Response example:
response.json
{
"message": null,
"query": {
"exclude": [
{
"extent": 200,
"points": [
{
"lat": 55.760012,
"lon": 37.610243
}
],
"severity": "hard",
"type": "point"
}
],
"locale": "en",
"output": "detailed",
"points": [
{
"lat": 55.775364,
"lon": 37.582591,
"type": "stop"
},
{
"lat": 55.765036,
"lon": 37.656625,
"type": "stop"
}
],
"transport": "driving"
},
"result": [
{
"algorithm": "with traffic jams",
"begin_pedestrian_path": {
"geometry": {
"selection": "LINESTRING(37.582590 55.775363, 37.583086 55.775486)"
}
},
"end_pedestrian_path": {
"geometry": {
"selection": "LINESTRING(37.656553 55.765080, 37.656625 55.765036)"
}
},
"filter_road_types": [
"highway"
],
"id": "4098442082976489221",
"maneuvers": [
{
"comment": "start",
"icon": "start",
"id": "12148121176576303699",
"outcoming_path": {
"distance": 30,
"duration": 13,
"geometry": [
{
"color": "normal",
"length": 9,
"selection": "LINESTRING(37.583086 55.775486, 37.583150 55.775405)",
"style": "normal"
},
{
"color": "fast",
"length": 21,
"selection": "LINESTRING(37.583150 55.775405, 37.583231 55.775307, 37.583253 55.775281, 37.583307 55.775231)",
"style": "normal"
}
],
"names": [
"площадь Тверская Застава"
]
},
"outcoming_path_comment": "30 m straight",
"type": "begin"
},
{
"comment": "Left turn",
"icon": "crossroad_left",
"id": "6150867020264593847",
"outcoming_path": {
"distance": 164,
"duration": 86,
"geometry": [
{
"color": "fast",
"length": 18,
"selection": "LINESTRING(37.583307 55.775231, 37.583561 55.775318)",
"style": "normal"
},
{
"color": "slow-jams",
"length": 58,
"selection": "LINESTRING(37.583561 55.775318, 37.583628 55.775341, 37.583734 55.775385, 37.583827 55.775434, 37.584035 55.775570, 37.584217 55.775689)",
"style": "normal"
},
{
"color": "slow",
"length": 79,
"selection": "LINESTRING(37.584217 55.775689, 37.584347 55.775775, 37.584624 55.775956, 37.584979 55.776188, 37.585058 55.776240)",
"style": "normal"
},
{
"color": "normal",
"length": 9,
"selection": "LINESTRING(37.585058 55.776240, 37.585154 55.776303)",
"style": "normal"
}
],
"names": []
},
"outcoming_path_comment": "150 m straight",
"turn_angle": -92,
"turn_direction": "left",
"type": "crossroad"
},
{
"comment": "Right turn onto 1-я Тверская-Ямская",
"icon": "crossroad_right",
"id": "10975701598661884069",
"outcoming_path": {
"distance": 1256,
"duration": 224,
"geometry": [
{
"color": "fast",
"length": 28,
"selection": "LINESTRING(37.585154 55.776303, 37.585445 55.776157, 37.585492 55.776131)",
"style": "normal"
},
{
"color": "normal",
"length": 588,
"selection": "LINESTRING(37.585492 55.776131, 37.585658 55.776039, 37.586214 55.775714, 37.588010 55.774663, 37.588280 55.774505, 37.590369 55.773281, 37.590635 55.773126, 37.592026 55.772311)",
"style": "normal"
},
{
"color": "fast",
"length": 185,
"selection": "LINESTRING(37.592026 55.772311, 37.592333 55.772132, 37.594081 55.771108)",
"style": "normal"
},
{
"color": "normal",
"length": 298,
"selection": "LINESTRING(37.594081 55.771108, 37.594993 55.770574, 37.595598 55.770219, 37.595740 55.770136, 37.595903 55.770019, 37.596125 55.769859, 37.596682 55.769461, 37.596711 55.769445, 37.597332 55.769104)",
"style": "normal"
},
{
"color": "slow",
"length": 157,
"selection": "LINESTRING(37.597332 55.769104, 37.598026 55.768722, 37.599143 55.768109)",
"style": "normal"
}
],
"names": [
"1-я Тверская-Ямская"
]
},
"outcoming_path_comment": "1.3 km straight",
"turn_angle": 91,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Right turn onto Благовещенский переулок",
"icon": "crossroad_right",
"id": "2418678000423127261",
"outcoming_path": {
"distance": 282,
"duration": 128,
"geometry": [
{
"color": "slow",
"length": 282,
"selection": "LINESTRING(37.599143 55.768109, 37.598984 55.768020, 37.598729 55.767877, 37.598486 55.767739, 37.598367 55.767674, 37.598289 55.767630, 37.598123 55.767537, 37.598037 55.767479, 37.597972 55.767421, 37.597911 55.767336, 37.597851 55.767189, 37.597840 55.767160, 37.597813 55.767093, 37.597784 55.767047, 37.597727 55.767009, 37.597296 55.766836, 37.596096 55.766356, 37.595993 55.766315)",
"style": "normal"
}
],
"names": [
"Благовещенский переулок"
]
},
"outcoming_path_comment": "300 m straight",
"turn_angle": 91,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Right turn onto Ермолаевский переулок",
"icon": "crossroad_right",
"id": "11041961544617596041",
"outcoming_path": {
"distance": 299,
"duration": 149,
"geometry": [
{
"color": "slow",
"length": 299,
"selection": "LINESTRING(37.595993 55.766315, 37.595925 55.766348, 37.595858 55.766362, 37.595846 55.766364, 37.595702 55.766372, 37.595123 55.766406, 37.595074 55.766409, 37.594998 55.766409, 37.594939 55.766408, 37.594813 55.766399, 37.594681 55.766371, 37.594660 55.766363, 37.593957 55.766079, 37.593699 55.765975, 37.593599 55.765935, 37.593526 55.765905, 37.593205 55.765777, 37.593152 55.765755, 37.592914 55.765659, 37.592836 55.765627, 37.592559 55.765516, 37.592159 55.765355, 37.591853 55.765231, 37.591807 55.765213)",
"style": "normal"
}
],
"names": [
"Ермолаевский переулок"
]
},
"outcoming_path_comment": "300 m straight",
"turn_angle": 67,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Right turn onto Малая Бронная",
"icon": "crossroad_right",
"id": "9787150399341892649",
"outcoming_path": {
"distance": 91,
"duration": 40,
"geometry": [
{
"color": "slow",
"length": 75,
"selection": "LINESTRING(37.591807 55.765213, 37.591725 55.765257, 37.591399 55.765428, 37.590912 55.765685)",
"style": "normal"
},
{
"color": "normal",
"length": 16,
"selection": "LINESTRING(37.590912 55.765685, 37.590722 55.765784)",
"style": "normal"
}
],
"names": [
"Малая Бронная"
]
},
"outcoming_path_comment": "90 m straight",
"turn_angle": 79,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Right turn onto Большая Садовая",
"icon": "crossroad_right",
"id": "16626882426047261420",
"outcoming_path": {
"distance": 4687,
"duration": 666,
"geometry": [
{
"color": "normal",
"length": 462,
"selection": "LINESTRING(37.590722 55.765784, 37.590908 55.765916, 37.591349 55.766228, 37.591622 55.766422, 37.591802 55.766547, 37.591951 55.766651, 37.592175 55.766807, 37.592529 55.767054, 37.592988 55.767375, 37.593622 55.767817, 37.594008 55.768087, 37.594339 55.768318, 37.594632 55.768511, 37.594932 55.768694, 37.595214 55.768858, 37.595486 55.769004)",
"style": "normal"
},
{
"color": "slow",
"length": 81,
"selection": "LINESTRING(37.595486 55.769004, 37.596007 55.769269, 37.596454 55.769495)",
"style": "tunnel"
},
{
"color": "normal",
"length": 28,
"selection": "LINESTRING(37.596454 55.769495, 37.596797 55.769669)",
"style": "tunnel"
},
{
"color": "slow",
"length": 87,
"selection": "LINESTRING(37.596797 55.769669, 37.597193 55.769869, 37.597838 55.770195)",
"style": "tunnel"
},
{
"color": "slow",
"length": 259,
"selection": "LINESTRING(37.597838 55.770195, 37.598115 55.770332, 37.598389 55.770458, 37.598674 55.770579, 37.599125 55.770758, 37.599606 55.770937, 37.599820 55.771001, 37.600450 55.771189, 37.600775 55.771293, 37.601329 55.771460)",
"style": "normal"
},
{
"color": "normal",
"length": 407,
"selection": "LINESTRING(37.601329 55.771460, 37.602336 55.771763, 37.602421 55.771789, 37.602861 55.771922, 37.603929 55.772247, 37.604227 55.772338, 37.604516 55.772426, 37.605210 55.772564, 37.605213 55.772565, 37.605268 55.772575, 37.605728 55.772651, 37.605822 55.772664, 37.607062 55.772839, 37.607333 55.772877)",
"style": "normal"
},
{
"color": "fast",
"length": 630,
"selection": "LINESTRING(37.607333 55.772877, 37.607382 55.772884, 37.608251 55.772986, 37.608986 55.773080, 37.609121 55.773096, 37.609234 55.773109, 37.610156 55.773194, 37.610728 55.773247, 37.611026 55.773277, 37.611498 55.773310, 37.612248 55.773363, 37.612442 55.773370, 37.613457 55.773408, 37.615054 55.773470, 37.617345 55.773557)",
"style": "normal"
},
{
"color": "normal",
"length": 370,
"selection": "LINESTRING(37.617345 55.773557, 37.619000 55.773621, 37.619209 55.773628, 37.621035 55.773684, 37.621922 55.773690, 37.623161 55.773671, 37.623250 55.773668)",
"style": "bridge"
},
{
"color": "normal",
"length": 250,
"selection": "LINESTRING(37.623250 55.773668, 37.624510 55.773622, 37.625672 55.773548, 37.625906 55.773531, 37.626549 55.773483, 37.627213 55.773398)",
"style": "normal"
},
{
"color": "slow",
"length": 212,
"selection": "LINESTRING(37.627213 55.773398, 37.627407 55.773378, 37.627898 55.773317, 37.628220 55.773274, 37.629057 55.773153, 37.630300 55.772978, 37.630537 55.772946)",
"style": "normal"
},
{
"color": "normal",
"length": 82,
"selection": "LINESTRING(37.630537 55.772946, 37.631810 55.772768)",
"style": "normal"
},
{
"color": "fast",
"length": 3,
"selection": "LINESTRING(37.631810 55.772768, 37.631859 55.772761)",
"style": "normal"
},
{
"color": "slow",
"length": 28,
"selection": "LINESTRING(37.631859 55.772761, 37.632302 55.772699)",
"style": "normal"
},
{
"color": "normal",
"length": 94,
"selection": "LINESTRING(37.632302 55.772699, 37.632528 55.772668, 37.633038 55.772597, 37.633286 55.772569, 37.633809 55.772511)",
"style": "normal"
},
{
"color": "fast",
"length": 604,
"selection": "LINESTRING(37.633809 55.772511, 37.635934 55.772276, 37.636482 55.772197, 37.636863 55.772130, 37.637246 55.772053, 37.637383 55.772024, 37.637746 55.771946, 37.638398 55.771787, 37.638671 55.771709, 37.639223 55.771539, 37.639458 55.771467, 37.640138 55.771258, 37.641596 55.770815, 37.642386 55.770573, 37.642720 55.770474)",
"style": "normal"
},
{
"color": "normal",
"length": 207,
"selection": "LINESTRING(37.642720 55.770474, 37.642942 55.770406, 37.643525 55.770234, 37.643708 55.770178, 37.643975 55.770092, 37.644348 55.769976, 37.644647 55.769882, 37.645657 55.769580)",
"style": "normal"
},
{
"color": "fast",
"length": 563,
"selection": "LINESTRING(37.645657 55.769580, 37.645818 55.769531, 37.646121 55.769442, 37.646389 55.769364, 37.647223 55.769158, 37.647789 55.769017, 37.648564 55.768776, 37.649337 55.768557, 37.649691 55.768459, 37.649817 55.768424, 37.649886 55.768391, 37.650113 55.768283, 37.650280 55.768171, 37.651022 55.767635, 37.651497 55.767307, 37.651966 55.766988, 37.652654 55.766522)",
"style": "normal"
},
{
"color": "normal",
"length": 320,
"selection": "LINESTRING(37.652654 55.766522, 37.653423 55.765990, 37.653591 55.765874, 37.653911 55.765652, 37.654967 55.764923, 37.655597 55.764466, 37.655881 55.764258)",
"style": "normal"
}
],
"names": [
"Большая Садовая"
]
},
"outcoming_path_comment": "4.7 km straight",
"turn_angle": 85,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "U-turn on Садовая-Черногрязская",
"icon": "turn_over_right_hand",
"id": "11556497815669521783",
"outcoming_path": {
"distance": 71,
"duration": 13,
"geometry": [
{
"color": "fast",
"length": 22,
"selection": "LINESTRING(37.655881 55.764258, 37.655917 55.764246, 37.655955 55.764239, 37.655993 55.764237, 37.656027 55.764240, 37.656049 55.764245, 37.656067 55.764253, 37.656086 55.764271, 37.656095 55.764288, 37.656094 55.764310, 37.656076 55.764339)",
"style": "normal"
},
{
"color": "slow",
"length": 49,
"selection": "LINESTRING(37.656076 55.764339, 37.655591 55.764691)",
"style": "normal"
}
],
"names": [
"Садовая-Черногрязская"
]
},
"outcoming_path_comment": "70 m straight",
"turn_angle": -180,
"turn_direction": "uturn_left",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "9403062809800045984",
"outcoming_path": {
"distance": 36,
"duration": 10,
"geometry": [
{
"color": "ignore",
"length": 21,
"selection": "LINESTRING(37.655591 55.764691, 37.655782 55.764778, 37.655867 55.764818)",
"style": "living_zone"
},
{
"color": "ignore",
"length": 12,
"selection": "LINESTRING(37.655867 55.764818, 37.656014 55.764887)",
"style": "archway"
},
{
"color": "ignore",
"length": 3,
"selection": "LINESTRING(37.656014 55.764887, 37.656064 55.764909)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "40 m straight",
"turn_angle": 89,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "10537508138935158189",
"outcoming_path": {
"distance": 93,
"duration": 27,
"geometry": [
{
"color": "ignore",
"length": 93,
"selection": "LINESTRING(37.656064 55.764909, 37.656554 55.764570, 37.656591 55.764558, 37.656635 55.764560, 37.656674 55.764578, 37.656728 55.764601, 37.656741 55.764609, 37.656749 55.764617, 37.656755 55.764630, 37.656755 55.764641, 37.656749 55.764655, 37.656538 55.764857)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "90 m straight",
"turn_angle": 90,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Left turn",
"icon": "crossroad_left",
"id": "6231828218228360487",
"outcoming_path": {
"distance": 21,
"duration": 6,
"geometry": [
{
"color": "ignore",
"length": 21,
"selection": "LINESTRING(37.656538 55.764857, 37.656510 55.764857, 37.656485 55.764865, 37.656303 55.764992)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "20 m straight",
"turn_angle": -46,
"turn_direction": "left",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "13949847164451370755",
"outcoming_path": {
"distance": 18,
"duration": 5,
"geometry": [
{
"color": "ignore",
"length": 18,
"selection": "LINESTRING(37.656303 55.764992, 37.656543 55.765075, 37.656553 55.765080)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "20 m straight",
"turn_angle": 91,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "finish",
"icon": "finish",
"id": "16377021944685554640",
"outcoming_path_comment": "You have arrived!",
"type": "end"
}
],
"reliability": 0.0,
"route_id": "moscow-cr-back.m1/carrouting/1772724288.519996",
"total_distance": 7048,
"total_duration": 1368,
"type": "carrouting",
"ui_total_distance": {
"unit": "km",
"value": "7"
},
"ui_total_duration": "22 min",
"waypoints": [
{
"original_point": {
"lat": 55.77548691400483,
"lon": 37.58308675494588
},
"projected_point": {
"lat": 55.77548691400483,
"lon": 37.58308675494588
},
"transit": false
},
{
"original_point": {
"lat": 55.76508099601444,
"lon": 37.65655367382703
},
"projected_point": {
"lat": 55.76508099601444,
"lon": 37.65655367382703
},
"transit": false
}
]
},
{
"algorithm": "with traffic jams",
"begin_pedestrian_path": {
"geometry": {
"selection": "LINESTRING(37.582590 55.775363, 37.583086 55.775486)"
}
},
"end_pedestrian_path": {
"geometry": {
"selection": "LINESTRING(37.656553 55.765080, 37.656625 55.765036)"
}
},
"filter_road_types": [
"highway"
],
"id": "11428461918364414999",
"maneuvers": [
{
"comment": "start",
"icon": "start",
"id": "7219311378236870105",
"outcoming_path": {
"distance": 1018,
"duration": 434,
"geometry": [
{
"color": "normal",
"length": 189,
"selection": "LINESTRING(37.583086 55.775486, 37.583150 55.775405, 37.583231 55.775307, 37.583253 55.775281, 37.583307 55.775231, 37.583444 55.775139, 37.583539 55.775074, 37.583571 55.775051, 37.583758 55.774941, 37.584051 55.774769, 37.584528 55.774490, 37.584715 55.774380, 37.584995 55.774215, 37.585056 55.774180, 37.585086 55.774162)",
"style": "normal"
},
{
"color": "slow",
"length": 320,
"selection": "LINESTRING(37.585086 55.774162, 37.585701 55.773802, 37.586019 55.773616, 37.586202 55.773508, 37.586336 55.773430, 37.586461 55.773356, 37.586789 55.773163, 37.587075 55.772996, 37.587113 55.772973, 37.587238 55.772900, 37.587446 55.772778, 37.587668 55.772648, 37.587824 55.772557, 37.588158 55.772360, 37.588212 55.772329, 37.588581 55.772112, 37.588708 55.772038)",
"style": "normal"
},
{
"color": "normal",
"length": 241,
"selection": "LINESTRING(37.588708 55.772038, 37.588822 55.771970, 37.589876 55.771353, 37.589952 55.771308, 37.590055 55.771248, 37.590487 55.770994, 37.590573 55.770943, 37.590753 55.770838, 37.591406 55.770455)",
"style": "normal"
},
{
"color": "fast",
"length": 55,
"selection": "LINESTRING(37.591406 55.770455, 37.592022 55.770093)",
"style": "normal"
},
{
"color": "normal",
"length": 213,
"selection": "LINESTRING(37.592022 55.770093, 37.592101 55.770047, 37.592212 55.769983, 37.592449 55.769843, 37.592770 55.769654, 37.593209 55.769397, 37.593661 55.769131, 37.593700 55.769108, 37.593817 55.769040, 37.593994 55.768937, 37.594028 55.768916, 37.594239 55.768793, 37.594289 55.768763, 37.594431 55.768680)",
"style": "normal"
}
],
"names": [
"площадь Тверская Застава"
]
},
"outcoming_path_comment": "1 km straight",
"type": "begin"
},
{
"comment": "Right turn onto Большая Садовая",
"icon": "crossroad_right",
"id": "17280681132982214891",
"outcoming_path": {
"distance": 1626,
"duration": 272,
"geometry": [
{
"color": "normal",
"length": 746,
"selection": "LINESTRING(37.594431 55.768680, 37.594346 55.768628, 37.593543 55.768059, 37.593308 55.767862, 37.592814 55.767453, 37.592717 55.767386, 37.592365 55.767140, 37.591674 55.766659, 37.591448 55.766501, 37.591024 55.766200, 37.590734 55.765995, 37.590646 55.765932, 37.590323 55.765704, 37.590212 55.765625, 37.589852 55.765370, 37.589556 55.765142, 37.589238 55.764885, 37.588929 55.764616, 37.588592 55.764313, 37.588277 55.764015, 37.588007 55.763744, 37.587735 55.763438, 37.587531 55.763196)",
"style": "normal"
},
{
"color": "slow",
"length": 437,
"selection": "LINESTRING(37.587531 55.763196, 37.587417 55.763061, 37.587347 55.762978, 37.586968 55.762487, 37.586911 55.762414, 37.586792 55.762252, 37.586305 55.761590, 37.586265 55.761535, 37.585827 55.760940, 37.585436 55.760408, 37.585400 55.760360, 37.585361 55.760297, 37.585229 55.760091, 37.584994 55.759724, 37.584986 55.759712, 37.584873 55.759517)",
"style": "normal"
},
{
"color": "normal",
"length": 33,
"selection": "LINESTRING(37.584873 55.759517, 37.584848 55.759474, 37.584719 55.759224)",
"style": "normal"
},
{
"color": "slow",
"length": 3,
"selection": "LINESTRING(37.584719 55.759224, 37.584702 55.759192)",
"style": "normal"
},
{
"color": "slow",
"length": 41,
"selection": "LINESTRING(37.584702 55.759192, 37.584583 55.758920, 37.584552 55.758831)",
"style": "normal"
},
{
"color": "slow",
"length": 3,
"selection": "LINESTRING(37.584552 55.758831, 37.584540 55.758798)",
"style": "normal"
},
{
"color": "normal",
"length": 241,
"selection": "LINESTRING(37.584540 55.758798, 37.584481 55.758631, 37.584447 55.758512, 37.584395 55.758321, 37.584344 55.758079, 37.584186 55.757315, 37.584176 55.757269, 37.584125 55.757023, 37.584043 55.756629)",
"style": "normal"
},
{
"color": "fast",
"length": 122,
"selection": "LINESTRING(37.584043 55.756629, 37.583822 55.755538)",
"style": "normal"
}
],
"names": [
"Большая Садовая"
]
},
"outcoming_path_comment": "1.6 km straight",
"turn_angle": 83,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Keep right on Новинский бульвар",
"icon": "crossroad_keep_right",
"id": "3402608619134083899",
"outcoming_path": {
"distance": 287,
"duration": 55,
"geometry": [
{
"color": "normal",
"length": 145,
"selection": "LINESTRING(37.583822 55.755538, 37.583700 55.755320, 37.583677 55.755270, 37.583651 55.755185, 37.583580 55.754874, 37.583460 55.754497, 37.583368 55.754261)",
"style": "normal"
},
{
"color": "slow",
"length": 142,
"selection": "LINESTRING(37.583368 55.754261, 37.583347 55.754147, 37.583324 55.754018, 37.583209 55.753360, 37.583139 55.752970)",
"style": "normal"
}
],
"names": [
"Новинский бульвар"
]
},
"outcoming_path_comment": "300 m straight",
"turn_angle": 10,
"turn_direction": "keep_right",
"type": "crossroad"
},
{
"comment": "U-turn on Новинский бульвар",
"icon": "turn_over_right_hand",
"id": "13965089567094593791",
"outcoming_path": {
"distance": 91,
"duration": 15,
"geometry": [
{
"color": "slow",
"length": 45,
"selection": "LINESTRING(37.583139 55.752970, 37.583154 55.752938, 37.583184 55.752911, 37.583221 55.752892, 37.583281 55.752879, 37.583339 55.752872, 37.583584 55.752866, 37.583623 55.752870, 37.583655 55.752880, 37.583683 55.752898, 37.583702 55.752933)",
"style": "normal"
},
{
"color": "normal",
"length": 46,
"selection": "LINESTRING(37.583702 55.752933, 37.583775 55.753348)",
"style": "normal"
}
],
"names": [
"Новинский бульвар"
]
},
"outcoming_path_comment": "90 m straight",
"turn_angle": -180,
"turn_direction": "uturn_left",
"type": "crossroad"
},
{
"comment": "Keep left on Новинский бульвар",
"icon": "crossroad_keep_left",
"id": "8264889756738919312",
"outcoming_path": {
"distance": 6154,
"duration": 849,
"geometry": [
{
"color": "normal",
"length": 1076,
"selection": "LINESTRING(37.583775 55.753348, 37.584019 55.754613, 37.584049 55.754877, 37.584040 55.754980, 37.584014 55.755103, 37.583987 55.755277, 37.583989 55.755285, 37.584368 55.757099, 37.584373 55.757134, 37.584393 55.757231, 37.584599 55.758224, 37.584616 55.758305, 37.584701 55.758610, 37.584799 55.758885, 37.584902 55.759123, 37.584918 55.759161, 37.584980 55.759280, 37.585062 55.759437, 37.585108 55.759517, 37.585197 55.759670, 37.585321 55.759863, 37.585480 55.760112, 37.585610 55.760316, 37.585641 55.760359, 37.585860 55.760655, 37.586396 55.761385, 37.586592 55.761651, 37.586717 55.761822, 37.586860 55.762016, 37.587004 55.762212, 37.587116 55.762364, 37.587445 55.762789)",
"style": "normal"
},
{
"color": "slow",
"length": 391,
"selection": "LINESTRING(37.587445 55.762789, 37.587551 55.762927, 37.587782 55.763201, 37.587849 55.763280, 37.587936 55.763384, 37.588134 55.763606, 37.588203 55.763684, 37.588416 55.763898, 37.588471 55.763953, 37.588784 55.764248, 37.588984 55.764428, 37.589118 55.764549, 37.589422 55.764814, 37.589738 55.765068, 37.590030 55.765294, 37.590045 55.765304, 37.590722 55.765784)",
"style": "normal"
},
{
"color": "normal",
"length": 462,
"selection": "LINESTRING(37.590722 55.765784, 37.590908 55.765916, 37.591349 55.766228, 37.591622 55.766422, 37.591802 55.766547, 37.591951 55.766651, 37.592175 55.766807, 37.592529 55.767054, 37.592988 55.767375, 37.593622 55.767817, 37.594008 55.768087, 37.594339 55.768318, 37.594632 55.768511, 37.594932 55.768694, 37.595214 55.768858, 37.595486 55.769004)",
"style": "normal"
},
{
"color": "slow",
"length": 81,
"selection": "LINESTRING(37.595486 55.769004, 37.596007 55.769269, 37.596454 55.769495)",
"style": "tunnel"
},
{
"color": "normal",
"length": 28,
"selection": "LINESTRING(37.596454 55.769495, 37.596797 55.769669)",
"style": "tunnel"
},
{
"color": "slow",
"length": 87,
"selection": "LINESTRING(37.596797 55.769669, 37.597193 55.769869, 37.597838 55.770195)",
"style": "tunnel"
},
{
"color": "slow",
"length": 259,
"selection": "LINESTRING(37.597838 55.770195, 37.598115 55.770332, 37.598389 55.770458, 37.598674 55.770579, 37.599125 55.770758, 37.599606 55.770937, 37.599820 55.771001, 37.600450 55.771189, 37.600775 55.771293, 37.601329 55.771460)",
"style": "normal"
},
{
"color": "normal",
"length": 407,
"selection": "LINESTRING(37.601329 55.771460, 37.602336 55.771763, 37.602421 55.771789, 37.602861 55.771922, 37.603929 55.772247, 37.604227 55.772338, 37.604516 55.772426, 37.605210 55.772564, 37.605213 55.772565, 37.605268 55.772575, 37.605728 55.772651, 37.605822 55.772664, 37.607062 55.772839, 37.607333 55.772877)",
"style": "normal"
},
{
"color": "fast",
"length": 630,
"selection": "LINESTRING(37.607333 55.772877, 37.607382 55.772884, 37.608251 55.772986, 37.608986 55.773080, 37.609121 55.773096, 37.609234 55.773109, 37.610156 55.773194, 37.610728 55.773247, 37.611026 55.773277, 37.611498 55.773310, 37.612248 55.773363, 37.612442 55.773370, 37.613457 55.773408, 37.615054 55.773470, 37.617345 55.773557)",
"style": "normal"
},
{
"color": "normal",
"length": 370,
"selection": "LINESTRING(37.617345 55.773557, 37.619000 55.773621, 37.619209 55.773628, 37.621035 55.773684, 37.621922 55.773690, 37.623161 55.773671, 37.623250 55.773668)",
"style": "bridge"
},
{
"color": "normal",
"length": 250,
"selection": "LINESTRING(37.623250 55.773668, 37.624510 55.773622, 37.625672 55.773548, 37.625906 55.773531, 37.626549 55.773483, 37.627213 55.773398)",
"style": "normal"
},
{
"color": "slow",
"length": 212,
"selection": "LINESTRING(37.627213 55.773398, 37.627407 55.773378, 37.627898 55.773317, 37.628220 55.773274, 37.629057 55.773153, 37.630300 55.772978, 37.630537 55.772946)",
"style": "normal"
},
{
"color": "normal",
"length": 82,
"selection": "LINESTRING(37.630537 55.772946, 37.631810 55.772768)",
"style": "normal"
},
{
"color": "fast",
"length": 3,
"selection": "LINESTRING(37.631810 55.772768, 37.631859 55.772761)",
"style": "normal"
},
{
"color": "slow",
"length": 28,
"selection": "LINESTRING(37.631859 55.772761, 37.632302 55.772699)",
"style": "normal"
},
{
"color": "normal",
"length": 94,
"selection": "LINESTRING(37.632302 55.772699, 37.632528 55.772668, 37.633038 55.772597, 37.633286 55.772569, 37.633809 55.772511)",
"style": "normal"
},
{
"color": "fast",
"length": 604,
"selection": "LINESTRING(37.633809 55.772511, 37.635934 55.772276, 37.636482 55.772197, 37.636863 55.772130, 37.637246 55.772053, 37.637383 55.772024, 37.637746 55.771946, 37.638398 55.771787, 37.638671 55.771709, 37.639223 55.771539, 37.639458 55.771467, 37.640138 55.771258, 37.641596 55.770815, 37.642386 55.770573, 37.642720 55.770474)",
"style": "normal"
},
{
"color": "normal",
"length": 207,
"selection": "LINESTRING(37.642720 55.770474, 37.642942 55.770406, 37.643525 55.770234, 37.643708 55.770178, 37.643975 55.770092, 37.644348 55.769976, 37.644647 55.769882, 37.645657 55.769580)",
"style": "normal"
},
{
"color": "fast",
"length": 563,
"selection": "LINESTRING(37.645657 55.769580, 37.645818 55.769531, 37.646121 55.769442, 37.646389 55.769364, 37.647223 55.769158, 37.647789 55.769017, 37.648564 55.768776, 37.649337 55.768557, 37.649691 55.768459, 37.649817 55.768424, 37.649886 55.768391, 37.650113 55.768283, 37.650280 55.768171, 37.651022 55.767635, 37.651497 55.767307, 37.651966 55.766988, 37.652654 55.766522)",
"style": "normal"
},
{
"color": "normal",
"length": 320,
"selection": "LINESTRING(37.652654 55.766522, 37.653423 55.765990, 37.653591 55.765874, 37.653911 55.765652, 37.654967 55.764923, 37.655597 55.764466, 37.655881 55.764258)",
"style": "normal"
}
],
"names": [
"Новинский бульвар"
]
},
"outcoming_path_comment": "6.2 km straight",
"turn_angle": 0,
"turn_direction": "keep_left",
"type": "crossroad"
},
{
"comment": "U-turn on Садовая-Черногрязская",
"icon": "turn_over_right_hand",
"id": "6746245032185442526",
"outcoming_path": {
"distance": 71,
"duration": 12,
"geometry": [
{
"color": "fast",
"length": 22,
"selection": "LINESTRING(37.655881 55.764258, 37.655917 55.764246, 37.655955 55.764239, 37.655993 55.764237, 37.656027 55.764240, 37.656049 55.764245, 37.656067 55.764253, 37.656086 55.764271, 37.656095 55.764288, 37.656094 55.764310, 37.656076 55.764339)",
"style": "normal"
},
{
"color": "slow",
"length": 49,
"selection": "LINESTRING(37.656076 55.764339, 37.655591 55.764691)",
"style": "normal"
}
],
"names": [
"Садовая-Черногрязская"
]
},
"outcoming_path_comment": "70 m straight",
"turn_angle": -180,
"turn_direction": "uturn_left",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "8339421901477512685",
"outcoming_path": {
"distance": 36,
"duration": 10,
"geometry": [
{
"color": "ignore",
"length": 21,
"selection": "LINESTRING(37.655591 55.764691, 37.655782 55.764778, 37.655867 55.764818)",
"style": "living_zone"
},
{
"color": "ignore",
"length": 12,
"selection": "LINESTRING(37.655867 55.764818, 37.656014 55.764887)",
"style": "archway"
},
{
"color": "ignore",
"length": 3,
"selection": "LINESTRING(37.656014 55.764887, 37.656064 55.764909)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "40 m straight",
"turn_angle": 89,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "3041915477570059658",
"outcoming_path": {
"distance": 93,
"duration": 26,
"geometry": [
{
"color": "ignore",
"length": 93,
"selection": "LINESTRING(37.656064 55.764909, 37.656554 55.764570, 37.656591 55.764558, 37.656635 55.764560, 37.656674 55.764578, 37.656728 55.764601, 37.656741 55.764609, 37.656749 55.764617, 37.656755 55.764630, 37.656755 55.764641, 37.656749 55.764655, 37.656538 55.764857)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "90 m straight",
"turn_angle": 90,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Left turn",
"icon": "crossroad_left",
"id": "12792482129946953359",
"outcoming_path": {
"distance": 21,
"duration": 6,
"geometry": [
{
"color": "ignore",
"length": 21,
"selection": "LINESTRING(37.656538 55.764857, 37.656510 55.764857, 37.656485 55.764865, 37.656303 55.764992)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "20 m straight",
"turn_angle": -46,
"turn_direction": "left",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "9802380948604771039",
"outcoming_path": {
"distance": 18,
"duration": 5,
"geometry": [
{
"color": "ignore",
"length": 18,
"selection": "LINESTRING(37.656303 55.764992, 37.656543 55.765075, 37.656553 55.765080)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "20 m straight",
"turn_angle": 91,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "finish",
"icon": "finish",
"id": "16377021944685554640",
"outcoming_path_comment": "You have arrived!",
"type": "end"
}
],
"reliability": 0.0,
"route_id": "moscow-cr-back.m1/carrouting/1772724288.521166",
"total_distance": 9415,
"total_duration": 1685,
"type": "carrouting",
"ui_total_distance": {
"unit": "km",
"value": "9.4"
},
"ui_total_duration": "28 min",
"waypoints": [
{
"original_point": {
"lat": 55.77548691400483,
"lon": 37.58308675494588
},
"projected_point": {
"lat": 55.77548691400483,
"lon": 37.58308675494588
},
"transit": false
},
{
"original_point": {
"lat": 55.76508099601444,
"lon": 37.65655367382703
},
"projected_point": {
"lat": 55.76508099601444,
"lon": 37.65655367382703
},
"transit": false
}
]
}
],
"status": "OK",
"type": "result"
}
Toll road costs
Information on toll roads is available for car and taxi routes only.
If the route passes through toll roads, you can get the total toll cost. Send a POST request to /routing/7.0.0/global with the following parameters:
-
[...]
